
   needs gtk api
   needs Pointer
   needs GSignal
\ ------------------------------------------------------------------------------
\  class GObject          OOP Module for csp4th                       MM-070504
\ ------------------------------------------------------------------------------
\                  Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------
   gtk api definitions
\ ------------------------------------------------------------------------------

   libgtk import g_object_get ( *g_obj *prop_name *prop_value 0 -- )

   libgtk import g_object_set ( *g_obj *prop_name param1 param2|0 0 -- )


   class GObject  GObject definitions  Pointer inherit  self seal

    macro ' GSignal alias signal (C -> <GSignal> )

    private  macro ' GObject alias GObject

    private  macro ' " alias "

    private  iface gint

    private  iface guint

    private  iface gpointer

    private  iface gchararray

    private  iface gboolean

    private  iface gdouble

\ ------------------------------------------------------------------------------
   GObject guint definitions
\ ------------------------------------------------------------------------------

   m: ! ( value oid a.prop_name u.prop_name -- )
      \? cr ." setting " 2dup type ."  on "
      drop >r self up @ (? dup . ) r> rot 0  dup g_object_set ;

   m: @ ( oid a.prop_name u.prop_name -- value )
      \? cr ." getting " 2dup type ."  from "
      drop >r >r 0 sp@ r> self up @ (? dup . ) r> rot 0 g_object_get ;

\ ------------------------------------------------------------------------------
   GObject gint definitions  self up guint inherit
\ ------------------------------------------------------------------------------

   m: ? ( oid a.prop_name u.prop_name -- ) self @ . ;

\ ------------------------------------------------------------------------------
   GObject gpointer definitions   self up guint inherit
\ ------------------------------------------------------------------------------


\ ------------------------------------------------------------------------------
   GObject gchararray definitions
\ ------------------------------------------------------------------------------

    m: ! ( a u oid a.property u.property -- )
     \ Store the string a;u in the object property a.proberty;u.property.
       >r >r >r zt r> r> r> GObject guint ! ;

    m: @ ( oid a.property u.property -- a' u' )
     \ Read the object property a.property;u.property.
       GObject guint @ zcount ;

    m: ? self @ type ;

\ ------------------------------------------------------------------------------
   GObject gboolean definitions
\ ------------------------------------------------------------------------------

    m: is ( <name> b -- )
          method create , 
          does> @ ( oid a.property u.property b -- )
                swap >r -rot r> ( b oid a.property u.property -- )
                GObject guint ! ;
              
    self 1 is on  ( oid a.property u.property -- )
    self 0 is off

    self m' on  alias yes
    self m' off alias no

    hide is

    GObject guint m' @ alias @ ( oid a.property u.property -- gboolean )

    m: ! ( gboolean oid a.property u.property -- )
         >r >r >r if 1 else 0 then  \ assure proper boolean value
         r> r> r> GObject guint ! ;

    m: ? ( oid a.property u.property -- )
       self @ if ." true" else ." false" then ;


\ ------------------------------------------------------------------------------
   GObject gdouble definitions
\ ------------------------------------------------------------------------------

    m: ! ( dl dh oid a.prop_name u.prop_name -- )
       (? cr ." setting " 2dup type ."  on " ) drop >r 
       self up @ (? dup . ) ( -- dl dh wid ) -rot r> -rot 0 g_object_set ;

    m: @ ( oid a.prop_name u.prop_name -- double )
       \? cr ." getting " 2dup type ."  from "
       drop >r >r 0 0 sp@ r> self up @ (? dup . ) r> rot 0 g_object_get swap ;

   [DEFINED] df.n

   [IF]  m: ? ( oid a.prop_name u.prop_name -- ) self @ 3 df.n ;  [THEN]

   oop
\ ------------------------------------------------------------------------------
\ Last revision: MM-090420 private macro GObject added
\                MM-090419 signal added, removed from GtkObject.4th
