
  needs gtk api
\ ------------------------------------------------------------------------------
\  class GSList                OOP Module for csp4th                  MM-080312
\ ------------------------------------------------------------------------------
\                        Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------
  gtk api definitions

   libglib import g_slist_free ( *list -- )
   libglib import g_slist_append ( *list data -- *list' )
   libglib import g_slist_nth  ( *list n -- *list )
   libglib import g_slist_length ( *list -- u )

  oop definitions  gtk api

  class GSList   GSList definitions  1 cells self allot   self seal

   m' @ alias @ ( oid -- a )
                \ Return the current address of the GSList.

   m: free ( oid -- )
           \? cr ." Freeing GSList " dup .
           dup @ g_slist_free off ;

   m: init ( 0|a.glist oid -- ) \ 0 = empty list
           \? cr ." Initializing GSList " dup . 
           dup @ if dup free drop then ! ;

   m: append ( x oid -- a.i )
             \ Append the value x to the GSList
             dup >r @ swap g_slist_append r> ! ;

   m: of ( i oid -- a.i )
         \ Return the address of the GSList element i
         \ The list elements are cell sized.
         @ swap g_slist_nth dup 
         0if ." Error: index out of GSList  " -1 throw then ;

   m: size ( oid -- u )
           \ Return the GList size
           @ g_slist_length ;

   m: first ( oid -- a.first )
            \ Return the data address of the first list element.
            @ ;

   m: last (O -- a.last )
           \ Return the data address of the last list element.
           this size 1- this of ;

   m: ? (O -- )
        \ Display the values of all list elements.
        this size 0 ?do i cr dup . ." : " this of @ . loop ;

  oop definitions
\ ------------------------------------------------------------------------------
\ Last revision: MM-090123 adapted to ANS-conform free
\                MM-090101  do loop ... -> DO LOOP ...
\                MM-080413 (O
\                MM-080312 code rewriten

0 [IF] \ test

   GSList new list    0 list init

   100 list append
   200 list append
   300 list append

[THEN]






