
   needs GObject
\ -----------------------------------------------------------------------------
\  class GdkPixbuf             OOP Module for csp4th                 MM-080313
\ -----------------------------------------------------------------------------
\                        Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------
  gtk api definitions

  libgdk import gdk_pixbuf_copy ( *pixbuf1 -- *pixbuf2 )
  libgdk import gdk_pixbuf_rotate_simple ( *pixbuf1 angle -- *pixbuf2 )
  libgdk import gdk_pixbuf_new_from_file ( *filename **error -- *pixbuf )
  libgdk import gdk_pixbuf_save ( *pixbuf *filename *type **error 0 -- flag ) 
  libgdk import gdk_pixbuf_scale_simple ( *pb1 w h GdkInterpType  -- *pb2 )
  libgdk import gdk_pixbuf_get_width ( *pixbuf -- int )
  libgdk import gdk_pixbuf_get_height ( *pixbuf -- int )
  libgdk import gdk_pixbuf_saturate_and_pixelate ( *pbs *pbd satur flag -- )

  libgtk import g_object_unref ( gpointer -- )

  oop definitions  gtk api

  class GdkPixbuf  GdkPixbuf definitions  GObject inherit  self seal

   m: init ( *pixbuf oid -- )
      \? cr ." Assigning GdkPixbuf " over . ." to " dup .
      self init ;

   m: free ( oid -- )
      dup self new? if drop exit then
      \? cr ." Unreferencing GdkPixbuf " dup @ . ." at " dup .
      dup self @ g_object_unref off ;

   m: ! ( *pixbuf oid -- )
      dup self free  self init ;

   m: @ ( oid -- *pixbuf )
      (? dup ) self @ \? cr ." Getting GdkPixbuf " dup . ." from " swap .
    ;

   m: copy ( oid -- *pixbuf )
      self @ gdk_pixbuf_copy ;


   m: rotate ( u oid -- pb )
      self @ swap gdk_pixbuf_rotate_simple ;

 \ GdkInterpTypes

   0 constant nearest
   1 constant tiles
   2 constant bilin
   3 constant hyper

   m: ?GdkInterpType ( u -- )
      0 3 between 0if ." Invalid GdkInterpType  " -1 throw then ;

   m: scale ( w h oid GdkInterpType -- a.pixbuf )
      dup self ?GdkInterpType >r
      self @ -rot r> gdk_pixbuf_scale_simple ;

   m: saturate (O sf.saturation flag.pixelate -- a.pixbuf )
      >r >r this @ dup r> r> gdk_pixbuf_saturate_and_pixelate 
      this @ ;


   iface save   self save definitions

    m: .png ( a u oid -- flag )
       self up @ -rot pad place " .png" pad +placez  pad 1+
       " png" zt 0 0 gdk_pixbuf_save not ;

  self up definitions

   m: width ( oid -- oid a u ) self " width" gint ;

   m: height ( oid -- oid a u ) self " height" gint ;

\   iface from  self from definitions  \ MM-090924
\
\    iface file  self file definitions

   iface from-file  self from-file definitions

    m: init ( a u oid -- )
       >r zt 0 gdk_pixbuf_new_from_file r> GdkPixbuf init ;

   \ should issue a message, if the file was not found, i.e. pixbuf = 0 !!!!!

  oop definitions
\ -----------------------------------------------------------------------------
\ Last revision: MM-090924 from file --> from-file
\                MM-090305 +place -> +placez in .png
