
  needs GtkBin
  needs GtkReliefStyle
\ ------------------------------------------------------------------------------
\  class GtkButton         OOP Module for csp4th                      MM-070727
\ ------------------------------------------------------------------------------
\                  Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------
  gtk api definitions

   libgtk import gtk_button_new ( -- *widget )

   libgtk import gtk_button_new_from_stock ( stock-id -- *widget )

  oop definitions  gtk api

  class GtkButton  GtkButton definitions  GtkBin inherit  self seal

  m: label (S oid -- ) self " label" gchararray ;

  m: relief (S oid -- oid a.prop u.prop ) self " relief" GtkReliefStyle ;

  m: use-stock ( oid -- )  self " use-stock" gboolean ;

  m: init (O a u -- wid )
     \? cr ." creating GtkButton "
     0if drop gtk_button_new else gtk_button_new_from_stock then this init ;

      \ The string a,u is a gtk stock-id or the button label.
      \
      \ a,u = stock-id ( eg. " gtk-ok" ) : A button with an icon and a label
      \                                    from the gtk stock is created.
      \
      \     = a string ( eg. " _Ende" ) : A button with the label a u is created,
      \                                   with a mnemonic, if the string contains
      \                                   an underscore.
      \
      \ a,0 : A button without a child widget is created.

  oop definitions
\ ------------------------------------------------------------------------------
\ Last revision: MM-090419  relief added
\                MM-080411  (O
