#! csp4th

  needs GtkToplevel
  needs GtkHBox
  needs GtkCheckButton
\ ------------------------------------------------------------------------------
\  GtkCheckButton Example 1 for csp4th                                MM-060901
\ ------------------------------------------------------------------------------

  GtkCheckButton definitions

  private vocabulary example.1  self example.1 definitions

  GtkToplevel    new window
  GtkHBox        new  hbox
  GtkCheckButton new   check.1
  GtkCheckButton new   check.2
  GtkCheckButton new   check.3

  :noname ( wid data -- ) 2drop gtk main_quit ; 2 20 cb cb.destroy

  :noname ( wid data -- )
          nip cr ." button " . ."  was toggled " ; 2 20 cb cb.toggled

  : run ( -- )
 
      " GtkCheckButton Example " window init

      6 window border-width !    200 window default-width !

      " destroy" cb.destroy 0 window signal connect drop

      hbox init window add   3 hbox spacing !

      " Check Button 1"  check.1 init  0 0 8 hbox pack_start

      " Check Button _2" check.2 init  0 0 8 hbox pack_start

                    " "  check.3 init  0 0 8 hbox pack_start

      " toggled" cb.toggled 1 check.1 signal connect drop
      " toggled" cb.toggled 2 check.2 signal connect drop
      " toggled" cb.toggled 3 check.3 signal connect drop

       window show_all

  ;

  hide cb.destroy  hide cb.toggled

  run term? [IF] ?? [ELSE] gtk main bye [THEN]
\ ------------------------------------------------------------------------------
\ Last revision: MM-090103  :: -> :noname
\                MM-080803  pack start -> pack_start
\                           show all -> show_all , gtk main -> gtk main_quit
