
  needs GtkWindow
  needs GtkVBox
\ ------------------------------------------------------------------------------
\  class GtkDialog              OOP module for csp4th                 MM-060529
\ ------------------------------------------------------------------------------
\                  Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------
  gtk api definitions

   libgtk import gtk_dialog_new ( -- *widget )
   libgtk import gtk_dialog_add_button ( *widget *btn-text response-id -- widget )
   libgtk import gtk_dialog_run ( *widget -- response-id )
   libgtk import gtk_dialog_set_default_response ( *widget response-id -- )

    -1 constant GTK_RESPONSE_NONE
    -4 constant GTK_RESPONSE_DELETE_EVENT \ Returned if a dialog is deleted.

  oop definitions  gtk api

  class GtkDialog  GtkDialog definitions  GtkWindow inherit

   GtkVBox this vbox

   self seal

   m: separator ( oid -- oid a.prop u.prop )
                self " has-separator" gboolean ;

   iface default-response  self default-response definitions  

     m: ! ( rid oid -- ) \ rid = response-id
        \? cr ." setting default-response " over . ." on GtkDialog "
        self up @ (? dup . ) swap gtk_dialog_set_default_response ;

   self up definitions

   m: init ( a1 u1 oid -- ) \? cr ." creating GtkDialog "
        >r gtk_dialog_new r@ GtkObject init
        gtk_bin_get_child r@ self vbox init gtk_container_add
        r@ self title !  r> self separator off ;
      ;

   m: run (O -- rid ) \? cr ." running dialog " this wid .
        this show_all  this wid gtk_dialog_run
        (? cr ." dialog response = " dup . ) ;

   iface button  self button definitions

    m: add ( a1 u1 rid oid -- )
           rot drop \? cr ." adding dialog button to "
           self up wid (? dup . ) 
           -rot gtk_dialog_add_button (? dup . ) drop ;

  oop definitions
\ ------------------------------------------------------------------------------
\ Last revision: MM-080803  show all -> show_all
