
  needs GtkToplevel
  needs GtkDialog
  needs GtkHBox
  needs GtkImageFromStock
  needs GtkLabel
\ ------------------------------------------------------------------------------
\  csp4th :  class GtkDialog Example.1                                MM-061227
\ ------------------------------------------------------------------------------

   GtkDialog definitions

   private vocabulary example.1  self example.1 definitions

   GtkToplevel new window
   GtkLabel    new  label
   GtkDialog   new dialog
   GtkHBox     new  hbox
   GtkImage    new   image
   GtkVBox     new   vbox
   GtkLabel    new    query
   GtkLabel    new    message

   :noname ( wid response-id data -- )
      cr ." Dialog response received, id = " . '. emit
    ; 2 20 cb cb.response

   :noname ( wid event data -- true|false ) \ the delete-event handler

      " GtkDialog Example 1" dialog init  dialog resizable no

      window wid dialog transient-parent !  dialog destroy-with-parent yes

      12 dialog vbox border-width !

      hbox init dialog vbox pack_start_defaults

      " gtk-dialog-question" image from-stock dialog-size init
      hbox pack_start_defaults

      vbox init hbox pack_end_defaults

      " <b>Programm beenden?</b>" query init  vbox pack_start_defaults

      query use-markup yes

      " Drücken Sie \"Abbrechen\", falls Sie das Programm <u>nicht</u> beenden wollen."

      message init  vbox pack_end_defaults

      message wrap yes   message use-markup yes

      12 message xpad !  6 message ypad !

      " gtk-cancel" -4 dialog button add

      " gtk-quit" false dialog button add   false dialog default-response !

      " response" cb.response 0 dialog signal connect drop

      dialog run  dialog destroy

   ; 3 40 cb cb.delete

  :noname ( wid data -- ) window destroy  gtk main_quit ;  2 20 cb cb.quit

  : run ( -- )

      " GtkDialog Example 1" window init   300 200 window default-size !

      "  Der Dialog erscheint beim Schießen des Fensters. " label init window add

      " delete-event" cb.delete 0 window signal connect drop
      " destroy"      cb.quit   0 window signal connect drop

      window show_all

      gtk pending

  ;

  hide cb.response  hide cb.delete  hide cb.quit

  run term? [IF] ?? cr [ELSE] gtk main bye [THEN]

\ ------------------------------------------------------------------------------
\ Last revision: MM-090921  Stack diagram for cb.response was wrong. fixed !
\                           label added to the main window
\                MM-090306  :: -> :noname
\                MM-081026  needs GtkImage -> needs GtkImageFromStock
\                MM-080803  gtk quit -> gtk main_quit , show all -> show_all
\                           pack defaults start -> pack_start_defaults
\                           pack defaults end -> pack_end_defaults
