
  needs GtkToplevel
  needs GtkButton
  needs GtkDialog
  needs GtkHBox
  needs GtkImageFromStock
  needs GtkLabel
  needs GtkFileChooserWidget
\ ------------------------------------------------------------------------------
\  csp4th :  class GtkDialog Example.2                                MM-061227
\ ------------------------------------------------------------------------------

   GtkDialog definitions

   private vocabulary example.2  self example.2 definitions

   GtkToplevel new window
   GtkButton   new  button
   GtkDialog   new dialog
   GtkHBox     new  hbox
   GtkImage    new   image
   GtkVBox     new   vbox
   GtkLabel    new    question
   GtkLabel    new    message
   GtkDialog   new dialog.2
   GtkFileChooserWidget new chooser

   :noname ( wid data -- )
      \? cr ." dialog respone signal received "
    ; 2 20 cb cb.response

   : show-dialog ( -- true|false )  \ delete-event handler

      " GtkDialog Example 1" dialog init

      12 dialog vbox border-width !

      window @ dialog transient-parent !  \ dialog destroy-with-parent yes

      dialog resizable no

      hbox init dialog vbox pack_start_defaults

      " gtk-dialog-question" image from-stock dialog-size init
      hbox pack_start_defaults

      vbox init hbox pack_end_defaults

      " <b>Programm beenden?</b>" question init  vbox pack_start_defaults

      question use-markup yes

      " Drücken Sie  \"Abbrechen\" , wenn Sie das Programm nicht beenden wollen."

      message init  vbox pack_end_defaults

      message wrap yes   12 message xpad !  6 message ypad !

      " gtk-cancel" -4 dialog button add

      " gtk-quit" false dialog button add   false dialog default-response !

      " response" cb.response 0 dialog signal connect drop

      dialog run  dialog destroy

   ;



   :noname ( wid event data -- true|false )  \ delete-event handler
      show-dialog
    ; 3 40 cb cb.delete

\ --------------

   : show-dialog.2 ( -- )

      " GtkFileChooserDialog" dialog.2 init

      500 350 dialog.2 size-request !

      window @ dialog.2 transient-parent !  \ dialog destroy-with-parent yes

      0 chooser init  dialog.2 vbox pack_start_defaults

      " gtk-cancel" -4 dialog.2 button add

      " gtk-quit" false dialog.2 button add   false dialog.2 default-response !

\      " response" cb.response 0 dialog.2 signal connect drop

      dialog.2 run  ." chooser response: " .   dialog.2 destroy

   ;

\ --

   :noname ( wid data -- ) cr ." clicked"
    \ show-dialog 0if window destroy then
      show-dialog.2
    ; 2 50 cb cb.clicked


  :noname ( wid data -- ) window destroy  gtk main_quit ;  2 20 cb cb.quit

  : run ( -- )

      " GtkDialog Example 2" window init   300 1 window default-size !

      " gtk-open" button init window add

      " clicked" cb.clicked 0 button signal connect drop

      " delete-event" cb.delete 0 window signal connect drop
      " destroy"      cb.quit   0 window signal connect drop

      window show_all

      gtk pending

  ;

  hide cb.response  hide cb.delete  hide cb.quit

  run term? [IF] ?? [ELSE] gtk main bye [THEN]

\ ------------------------------------------------------------------------------
\ Last revision: MM-090306  :: -> :noname
\                MM-080803  gtk quit -> gtk main_quit , show all -> show_all
