
  needs GtkToplevel
  needs GtkHBox
  needs GtkVBox
  needs GtkEventBox
  needs GtkImageFromStock
  needs GtkImageFromFile
  needs GtkLabel
  needs GtkTooltips
\ -----------------------------------------------------------------------------
\  GtkImage example 1 for csp4th                                     MM-070406
\ -----------------------------------------------------------------------------

  GtkImage definitions

  private vocabulary example.1  self example.1 definitions

  GtkToplevel       new window
  GtkVBox           new  vbox
  GtkHBox           new   hbox
  GtkEventBox       new    ebox.0
  GtkImage new     image.0
  GtkEventBox       new    ebox.1
  GtkImage new     image.1
  GtkEventBox       new    ebox.2
  GtkImage new     image.2
  GtkEventBox       new    ebox.3
  GtkImage new     image.3
  GtkEventBox       new    ebox.4
  GtkImage new     image.4
  GtkEventBox       new    ebox.5
  GtkImage new     image.5
  GtkEventBox new    ebox.6
  GtkImage    new     image.6
  GtkLabel    new   info

  GtkTooltips new tips

  :noname ( wid 0 -- ) tips destroy gtk main_quit
   ; 2 20 cb cb.quit

  : run ( -- )
 
    0 0 gtk init

    " GtkImage Examples Version 1" window init  6 window border-width !

    vbox init  3 vbox spacing !  window add

    hbox init  3 hbox spacing !  vbox pack_start_defaults

    ebox.0 init  hbox pack_start_defaults
    ebox.1 init  hbox pack_start_defaults
    ebox.2 init  hbox pack_start_defaults
    ebox.3 init  hbox pack_start_defaults
    ebox.4 init  hbox pack_start_defaults
    ebox.5 init  hbox pack_start_defaults
    ebox.6 init  hbox pack_start_defaults

    " gtk-dialog-info" image.0 from-stock menu-size init  ebox.0 add
    " gtk-dialog-info" image.1 from-stock small-toolbar-size init  ebox.1 add
    " gtk-dialog-info" image.2 from-stock large-toolbar-size init  ebox.2 add
    " gtk-dialog-info" image.3 from-stock button-size init  ebox.3 add
    " gtk-dialog-info" image.4 from-stock dnd-size init  ebox.4 add
    " gtk-dialog-info" image.5 from-stock dialog-size init  ebox.5 add
    " icons/butterfly.png" /?/ image.6 from-file init  ebox.6 add

    " Place the mouse pointer over an image to see its tooltip." info init

    0 0 0 vbox pack_start

    tips init

    " Image.0 'dialog-info' from stock, menu-size."          ebox.0 wid tips !
    " Image.1 'dialog-info' from stock, small-toolbar-size." ebox.1 wid tips !
    " Image.2 'dialog-info' from stock, large-toolbar-size." ebox.2 wid tips !
    " Image.3 'dialog-info' from stock, button-size."        ebox.3 wid tips !
    " Image.4 'dialog-info' from stock, dnd-size."           ebox.4 wid tips !
    " Image.5 'dialog-info' from stock, dialog-size."        ebox.5 wid tips !
    " Image.6 from file" " icons/butterfly.png" /?/ bl join  ebox.6 wid tips !

    " destroy" cb.quit 0 window signal connect drop

    window show_all

  ;

  hide cb.quit

  run term? [IF] ?? [ELSE] gtk main bye [THEN]
\ -----------------------------------------------------------------------------
\ Last revision: MM-090306  :: -> :noname
\                MM-080803  pack defaults start -> pack_start_defaults
\                           pack start -> pack_start
\                           gtk quit -> gtk main_quit , show all -> show_all
