
   needs gtk api
   needs GObject
\   needs GtkSignal
\ ------------------------------------------------------------------------------
\  class GtkObject          OOP Module for csp4th                     MM-070504
\ ------------------------------------------------------------------------------
\                     Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------
   gtk api definitions
\ ------------------------------------------------------------------------------

   libgtk import gtk_object_destroy ( *widget -- )

   class GtkObject  GtkObject definitions  GObject inherit  self seal

    :noname ( widget oid -- ) off (? cr ." destroying widget " . )
    ; 2 10 cb cb.o

    private

    macro ' GtkObject alias GtkObject

    public

    self  m' @ alias wid (S oid -- wid )

    m: init (O wid -- )
         dup if (? dup . ) dup this init 
             else ." Error : could not create GtkObject  " -1 throw
             then
         " destroy" self cb.o this dup signal connect drop ;

    m: destroy (O -- )
         this new? if exit then this wid gtk_object_destroy ;

   oop
\ ------------------------------------------------------------------------------
\ Last revision: MM-090419  signal-method moved to GObject.4th
\                MM-090419  (GtkObject) added
\                MM-090306  :: -> :noname
\                MM-080409  (O
\                MM-080303  hide cb.o removed because 'cb' now creates private
\                           callback handlers in class and iface contexts.
\                MM-071231  cb: renamed to cb
