  needs GtkContainer
\ ------------------------------------------------------------------------------
\  class GtkPaned            OOP Module for csp4th                    MM-070729
\ ------------------------------------------------------------------------------
\                     Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------

  gtk api definitions

   libgtk import gtk_paned_add1 ( *paned *child -- )
   libgtk import gtk_paned_add2 ( *paned *child -- )
   libgtk import gtk_paned_pack1 ( *paned *child resize shrink -- )
   libgtk import gtk_paned_pack2 ( *paned *child resize shrink -- )

  class GtkPaned  GtkPaned definitions  GtkContainer inherit  self seal

   m: paned_add ( wid.child wid.paned i -- )
          >r self wid
          \? cr ." adding " over . ." to pane" r@ . ." of " dup .
          swap r> 1- 0if gtk_paned_add1 else gtk_paned_add2 then ;

   m: add1 ( wid oid -- )
           1 self paned_add ;

   m: add2 ( wid oid -- )
           2 self paned_add ;

   hide paned_add

   m: paned_pack ( wid resize shrink oid i -- )
      >r self wid
      \? cr ." packing " 3 pick . ." to pane" r@ . ." of " dup .
      swap >r swap >r swap r> r> 
      r> 1- 0if gtk_paned_pack1 else gtk_paned_pack2 then ;

  m: pack1 ( wid resize shrink oid -- )
           1 self paned_pack ;

  m: pack2 ( wid resize shrink oid -- )
           2 self paned_pack ;

  hide paned_pack

  oop definitions
\ ------------------------------------------------------------------------------
\ Last revision: MM-080810  i of paned add  -> paned addi
\                           i of paned pack -> paned packi 
\                MM-080415  (O
