
  needs GtkToplevel
  needs GtkHBox
  needs GtkRadioButton
  needs GtkImageFromStock
\ ------------------------------------------------------------------------------
\  csp4th OOP              GtkRadioButton example.1                   MM-070323
\ ------------------------------------------------------------------------------
\                      Copyright (C) 2008 Manfred Mahlow
\
\                      This code is in the public domain.
\ ------------------------------------------------------------------------------
  GtkRadioButton definitions

  private vocabulary example.1  self example.1 definitions

  GtkToplevel    new window
  GtkHBox        new  hbox
  GtkRadioButton new   button.1
  GtkRadioButton new   button.2
  GtkRadioButton new   button.3
  GtkRadioButton new   button.4
  GtkImage       new    image

  :noname ( wid data -- ) 2drop gtk main_quit ;  2 20 cb cb.destroy

  :noname ( wid data -- )
          cr ." button " . space sp@ GtkRadioButton active @
          0if ." is no longer active" else ." is active now" then 
          ; 2 20 cb cb.toggled

  : run ( -- )
 
      " GtkRadioButton Example" window init

      3 window border-width !    100 window default-width !

      hbox init  16 hbox spacing !  window add

      " destroy" cb.destroy 0 window signal connect drop


      0  \ start of radio button list
      " "                button.1 init dup hbox pack_start_defaults
      " Radio Button 2"  button.2 init dup hbox pack_start_defaults
      " Radio Button _3" button.3 init dup hbox pack_start_defaults
      " "                button.4 init     hbox pack_start_defaults

      " gtk-ok" image from-stock menu-size init  button.4 add

      " toggled" cb.toggled 1 button.1 signal connect drop
      " toggled" cb.toggled 2 button.2 signal connect drop
      " toggled" cb.toggled 3 button.3 signal connect drop
      " toggled" cb.toggled 4 button.4 signal connect drop

       window show_all

  ;

  hide cb.destroy  hide cb.toggled

  run term? [IF] ?? [ELSE] gtk main bye [THEN]
\ ------------------------------------------------------------------------------
\ Last revision: MM-090103  :: -> :noname
\                MM-080803  pack defaults start -> pack_start_defaults
\                           show all -> show_all , gtk main -> gtk main_quit
