
  needs GtkToplevel
  needs GtkTable
  needs GtkFrame Array
  needs GtkLabel Array

\ ------------------------------------------------------------------------------
\  GtkTable example 2 for cspForth                                    MM-080601
\ ------------------------------------------------------------------------------
\                      Copyright (C) 2008 Manfred Mahlow
\
\                      This code is in the public domain.
\ ------------------------------------------------------------------------------

  GtkTable definitions

  private vocabulary example.2  self example.2 definitions  also gtk api

  :noname ( wid data -- ) gtk main_quit ;  2 10 cb cb.destroy

  GtkToplevel    new window
  GtkTable       new  table
  GtkFrame Array new   frames
  GtkLabel Array new    labels

  GTK_EXPAND GTK_SHRINK or GTK_FILL or constant xopts
                                 xopts constant yopts

  : run ( -- )
        " GtkTable Example 2" window init  250 window default-width !
        " destroy" cb.destroy 0 window signal connect drop
        table init window add
        5 frames init
        pad 0 0 frames of init 0 1 0 1 yopts xopts 0 0 table attach
        pad 0 1 frames of init 1 2 0 1 yopts xopts 0 0 table attach
        pad 0 2 frames of init 0 2 1 2 yopts xopts 0 0 table attach
        pad 0 3 frames of init 2 3 0 2 yopts xopts 0 0 table attach
        pad 0 4 frames of init 0 3 2 3 yopts xopts 0 0 table attach
        5 labels init
        " 0-1,0-1" 0 labels of init  0 frames of add
        " 1-2,0-1" 1 labels of init  1 frames of add
        " 0-2,1-2" 2 labels of init  2 frames of add
        " 2-3,0-2" 3 labels of init  3 frames of add
        " 0-3,2-3" 4 labels of init  4 frames of add
        window show_all
   ;

  run term? [IF] previous ?? [ELSE] gtk main bye [THEN]
\ ------------------------------------------------------------------------------
\ Last revision: MM-090306  :: -> :noname
\                MM-080803  gtk quit -> gtk main_quit , show all -> show_all

