
  needs GtkToplevel
  needs GtkTreeView
  needs GtkTreeViewColumn
  needs GtkTreeViewColumn Array
  needs GtkListStore
  needs GtkCellRendererText
  needs GtkTreeIter
\ ------------------------------------------------------------------------------
\  cspForth :  GtkTreeView example 2                                  MM-080602
\ ------------------------------------------------------------------------------
\                      Copyright (C) 2008 Manfred Mahlow
\
\                      This code is in the public domain.
\ ------------------------------------------------------------------------------

  gtk api definitions

  libgtk import gtk_tree_path_to_string ( *path -- *char )

  libgtk import g_free ( *char -- )


  GtkTreeView definitions

  private vocabulary example.1  self example.1 definitions  also gtk api

  GtkToplevel             new window
  GtkTreeView             new  view
  GtkTreeViewColumn       new   index
  GtkTreeViewColumn Array new   columns

  GtkCellRendererText     new  renderer
  GtkListStore            new  list


   : get ( -- ? ) view selection @ 0if exit ." No item selected.  " -1 throw then
         list row ! 
         5 0 do i list value @ type space space loop drop ;


  :noname ( wid data -- )   list free  gtk quit
  ;  2 20 cb cb.destroy

  :noname ( wid.view path wid.column data -- )
     cr ." row activated on " >r rot . ." : "
     swap ." path=" dup . gtk_tree_path_to_string dup zcount type g_free
     ." , *column=" . r> ." , data=" .  cr get
   ; 4 20 cb cb.sel0

  :noname ( wid data -- ) cr ." Column " . ." : wid=" .
  ; 2 20 cb cb.clicked


  : run ( -- )

      " GtkTreeView example 1" window init   window position center

      5 window border-width !    275 150 window resize

      view init window add   renderer init

      view rules-hint on  0 view search-column !

      dup " ID" " text" 0 index init view append

      4 columns init

      dup " Name"        " text" 1  0 columns of init view append
      dup " Strasse Nr." " text" 2  1 columns of init view append
      dup " PLZ"         " text" 3  2 columns of init view append
          " Ort"         " text" 4  3 columns of init view append


      G_TYPE_INT  G_TYPE_STRING  G_TYPE_STRING  G_TYPE_STRING  G_TYPE_STRING

      5 list init view model !

      list append  0 0 list value !
                   " Luise Musterfrau" 1 list text !
                   " Oldenburger Str. 25" 2 list text !
                   " 28219" 3 list text !
                   " Bremen" 4 list text !

      list append  1 0 list value !
                   " Otto Mustermann" 1 list text !
                   " Schillerstr. 97" 2 list text !
                   " 28218"  3 list text !
                   " Bremen" 4 list text !

      list append  2 0 list value !
                   " Museum für Brotkultur" 1 list text !
                   " Salzstadelgasse 10" 2 list text !
                   " " 3 list text !
                   " Ulm" 4 list text !

     index sort indicator on
     index sort ascending
     index clickable on

     4 0 do i columns of resizable on
            i columns of clickable yes
            " clicked" cb.clicked i 1+ i columns of signal connect drop
         loop

      " destroy" cb.destroy 0 window signal connect drop

      " row-activated" cb.sel0 0 view signal connect drop

      " clicked" cb.clicked 0 index signal connect drop

      window show all

   ;

   appdir " popen.4th" 'ps join slurp over swap evaluate close

   variable lines  0 lines !
   variable cols

   : list-append ( a u -- )
        zt " r" zt popen ?dup 0if ." popen failed " -1 throw then >r
        begin cr cols off pad 80 r@ fgets while
          pad zcount 10 -skip
          list append
          lines @ cols @ list value ! cols ++
          begin ', split while "" 2dup type space cols @ list text ! cols ++ repeat
               "" 2dup type space cols @ list text ! cols ++
              lines ++ repeat
        r> pclose drop ;

          
   hide cb.sel0  hide cb.clicked  hide cb.destroy

\   previous
    also self

   run term? [IF] ?? [ELSE] gtk main bye [THEN]

   list clear   " cat" appdir " nosql" 'ps join bl join list-append

\ ------------------------------------------------------------------------------
\ Last revision: MM-090307  DO LOOP ... -> do loop ...
\                MM-090306  :: -> :noname
\                MM-090101  do loop ... -> DO LOOP ...
