
  needs GtkContainer
\ ------------------------------------------------------------------------------
\  class GtkTreeViewColumn     OOP Module for csp4th                  MM-060931
\ ------------------------------------------------------------------------------
\                       Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------

  gtk api definitions

  libgtk import gtk_tree_view_column_new_with_attributes ( *title *renderer *attr store-col# 0 -- *widget )

  libgtk import gtk_tree_view_column_add_attribute ( *widget *renderer attr store-col# -- )

  libgtk import  gtk_tree_view_column_set_attributes
             as  gtk_tree_view_column_set_attribute ( *widget *renderer attr store-col# 0 -- )


\ libgtk import gtk_tree_view_column_new ( -- *widget )


  oop definitions  gtk api

  class GtkTreeViewColumn  GtkTreeViewColumn definitions  GtkObject inherit

   self seal

   m: title ( oid -- ) self " title" gchararray ;

   m: resizable ( oid -- ) self " resizable" gboolean ;

   m: reorderable ( oid -- ) self " reorderable" gboolean ;

   m: clickable ( oid -- ) self " clickable" gboolean ;

   m: init (O renderer a.title u.title a.attr u.attr col# -- wid )
        \? cr ." creating tree view column "
        >r drop >r drop swap r> r> 0
        gtk_tree_view_column_new_with_attributes this ( super) init ;

   m: add.attribute (O *renderer a.attr u.attr store-col# -- )
        \? cr ." adding attribute to tree view column "
        >r drop >r >r this wid (? dup . ) r> r> r>
        gtk_tree_view_column_add_attribute ;

   m: set.attribute (O *renderer a.attr u.attr store-col# -- )
        \? cr ." setting attribute on tree view column "
        >r drop >r >r this wid (? dup . ) r> r> r> 0
        gtk_tree_view_column_set_attribute ;


  iface sort   self sort definitions

   m: indicator ( oid -- ) self up " sort-indicator" gboolean ;

   m: ascending ( oid -- ) self up " sort-order" gboolean off ;

   m: descending ( oid -- ) self up " sort-order" gboolean on ;

  self up definitions  oop
\ ------------------------------------------------------------------------------
\ Last revision: MM-080416  (O
