
  needs GtkToplevel
  needs GtkVPaned
  needs GtkFrame
\ ------------------------------------------------------------------------------
\  csp4th OOP                 GtkVPaned example.1                     MM-070321
\ ------------------------------------------------------------------------------
\                      Copyright (C) 2008 Manfred Mahlow
\
\                      This code is in the public domain.
\ ------------------------------------------------------------------------------

  GtkVPaned definitions

  private vocabulary example.1  self example.1 definitions

  GtkToplevel new window      
  GtkVPaned   new  paned
  GtkFrame    new   frame.1
  GtkFrame    new   frame.2

  :noname ( wid data -- ) gtk main_quit ;  2 10 cb cb.destroy

  : run ( -- )
      " GtkVPaned Example" window init
      6 window border-width !     300 window width-request !
      " destroy" cb.destroy 0 window signal connect drop

      paned init window add
      "  Pane 1 " frame.1 init paned add1
      "  Pane 2 " frame.2 init true true paned pack2

      150 frame.1 height-request !
      150 frame.2 height-request !

      window show_all
  ;

  hide cb.destroy

  run term? [IF] ?? [ELSE] gtk main bye [THEN]
\ ------------------------------------------------------------------------------
\ Last revision: MM-090306  :: -> :noname
\                MM-080810  i of paned add  -> paned addi
\                           i of paned pack -> paned packi 
\                MM-080803  gtk quit -> gtk main_quit , show all -> show_all
