\ -----------------------------------------------------------------------------
\  TinyTerm example 1 for csp4th                                     MM-090105
\ -----------------------------------------------------------------------------
\
\                      Copyright (C) 2009 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
\ To run this example enter  needs TinyTerm example.1  on the csp4th command
\ line or enter csp4th -n "TinyTerm example.1" in an X-Terminal.

  needs TinyTerm

  TinyTerm definitions decimal  c api

  private TinyTerm new example.1

  B38400 CS8 or PARNONE or ONESTOPB or CREAD or CLOCAL or   \ cflags
   0                 \ iflags : no imput processing
   \ ICRNL           \ iflags : change received CR to NL
   0                 \ oflags : no output processing
   \ ONLCR OPOST or  \ oflags : change outgoing NL to CR+NL
   0                 \ lflags
   " /dev/ttyS0"     \ device name
   0                 \ use the default rx-handler
   :noname (O b --) dup 10 = if drop 13 then this tx drop ;  \ the tx-handler

   self example.1 init     \ init terminal in raw mode

   public oop definitions

   TinyTerm example.1 B9600 8N1 open

\ -----------------------------------------------------------------------------
\  Last revision: MM-090301
