\ -----------------------------------------------------------------------------
\  gtk api                  OOP Module for csp4th                    MM-060901
\ -----------------------------------------------------------------------------
\
\                     Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
 
  needs Cell
  needs c api termios
 
  oop definitions
 
  iface gtk (C -> <gtk> ) (S -- )
 
  gtk definitions
 
  self seal
 
  vocabulary api  \ A context to hold GTK functions and constants.
 
  gtk api definitions
 
  lib new libglib  " libglib-2.0.so.0"    libglib init
  lib new libgdk   " libgdk-x11-2.0.so.0" libgdk init
  lib new libgtk   " libgtk-x11-2.0.so.0" libgtk init
 
  libgtk import gtk_init ( argc argv -- )
 
  libgtk import gtk_main ( -- )
 
  libgtk import gtk_main_quit ( -- )
 
  libgtk import gtk_events_pending ( -- t|f )
 
  libgtk import gtk_main_iteration ( -- )
 
  gtk definitions  gtk api
 
  m: pending (S -- )
     begin
       gtk_events_pending 0if exit then
       ['] gtk_main_iteration catch
\      ?dup if ." Background Error, Caught: " . then  \ MM-090813
       ?dup if ." Background Error, Caught: " .  sp0 cell+ @ sp0 !  then
     again ;
 
  m: init ( x1 x2 -- )
     (? cr ." initializing gtk  " ) gtk_init ;
 
  Cell new loops  self 0 loops init
 
  m: main ( -- )
     self loops inc gtk_main ;
 
  m: main_quit ( -- )
     self loops @ if gtk_main_quit self loops dec then ;

 :noname ( -- ) \ Init gtk on startup.
    0 0 self init
  ; dup onstartup execute
 
  :noname ( -- c ) \ Change key to process pending gtk events.
     begin
       gtk_events_pending if gtk pending then
       key? if [ ' key defer@ compile, ] exit then
     again
   ; is key
  forth definitions
 
  : term? ( -- ? )
\   [ c api ] 0 ( = fd of stdin ) pad termios @ ioerr @ 0 = [ gtk api ] ;
    [ c api ] 0 ( = fd of stdin ) pad termios read 0 = [ gtk api ] ;

  oop definitions
\ -----------------------------------------------------------------------------
\  Last revision: MM-090813  pending changed to restore sp0 on background error
\                 MM-090306  :: -> :noname
\                 MM-090213  term? changed to use termios read instead of 
\                            termios @.
\                 MM-080803  gtk quit -> gtk main_quit
\                 MM-080531  Reva repeat while -> begin 0until
\                 MM-080229  terminal? -> term?
