| file i/o words:

defer 'ps | replaces pathsep  MM-080205

(os) [IF]
        :noname '/ ; is 'ps
	| : pathsep '/ ;  | 080205
      |	: (seek) ( whence offset handle ) 3 19 syscall ;  MM-090920
      |	: rename zt -rot zt 3 38 syscall ioerr ! ;        MM-080322
      |	: rename zt -rot zt 2 38 syscall ioerr ! ;        MM-090920
	: rename-file ( a1 u1 a2 u2 -- ior ) zt -rot zt 2 38 syscall ;

      | : delete  ( a n -- ) zt 1 10 syscall ioerr ! ;
	: delete-file ( a u -- ior ) zt 1 10 syscall ;      | MM-090920

      | : ioctl ( args request #args fd -- n )  | MM-080216
      |         swap 2 + #54 ( __NR_ioctl ) syscall dup 0 min ioerr ! ;

        : ioctl ( args request #args fd -- n ior )  | MM-090213
                swap 2 + #54 ( __NR_ioctl ) syscall dup 0 min ;

        0 constant r/o
        1 constant w/o
        2 constant r/w

        | ior = 0 : no error
        | ior < 0 = err#       see /usr/include/linux/errno.h

|        : open-file ( a u fam -- fid ior ) | MM-090125  MM-090808
|            >r zt r> sys-open dup 0 min ;

|        : create-file ( a u fam -- fid ior ) | MM-090204  MM-090808
|            >r zt r> sys-creat dup 0 min ;

|        hide sys-open  hide sys-creat

create stat_buf 100 allot
	| st_dev
	| st_ino
	| st_mod
	| st_nlink
	| st_uid
	| st_gid
	| st_rdev
	| st_size
	| st_blksize
	| st_blocks
	| st_atime
	| st_mtime
	| st_ctime
	|
	| +8 = st_mode
	| +44 = st_mtime
	| .dev	rd 2 	; + 0
	| 	rd 1 	; + 8; pad
	| .inode	rd 1	; +12
	| .mode	rd 1	; +16
	| .nlink	rd 1	; +20
	| .uid	rd 1	; +24
	| .gid	rd 1	; +28
	| .rdev	rd 2	; +32
	| 	rd 1	; +40 pad
	| .size	rd 1	; +44
	| .hsize	rd 1	; +48
	| .blksize rd 1	; +52
	| .blocks	rd 1	; +56
	| pad rd1             +60
	| .atime	rd 1	; +64
	| pad rd1             +68
	| .mtime	rd 1	; +72
	| pad rd1			  +76
	| .ctime	rd 1	; +80
	| 	rd 6	; -- +100
	
	: (stat) ( a n -- x ) zt stat_buf swap 2 195 syscall ioerr ! ;
	: stat ( a n -- x ) (stat) stat_buf 16 + @ ;
	: mtime ( a n -- x ) (stat) stat_buf 72 + @ ;
	hide (stat)
	hide stat_buf
[ELSE]
        :noname '\ ; is 'ps
	| : pathsep '\ ;   MM-080205
k32 drop
: sm/rem ( d n -- rem div )
	[ $89adc389 , $fbf7adc2 , $fc768d92 , $d0890689 , ;
loc:
	" SetFilePointer" 4 func SetFilePointer
	" MoveFileA" 2 func MoveFile
	" DeleteFileA" 1 func DeleteFile
	" GetFileAttributesA" 1 func GetFileAttributes
	" GetFileTime" 4 func GetFileTime
	| stat:
	: stat zt GetFileAttributes ;
	| delete:
	: delete zt DeleteFile not ioerr ! ;
	| rename:
	: rename zt -rot zt swap MoveFile not ioerr ! ;
	| return ($FILETIME - 116444736000000000) / 10000000; 
	| subtrahend is: -717324288 27111902
	: FILETIME>unixtime ( d  -- n)
		27111902 - swap -717324288 - swap
		10000000 sm/rem nip
		;
        : mtime open/r ioerr @ if drop -1 exit then
		>r | fh
		r@ 0 0 here GetFileTime if
			here 2@ FILETIME>unixtime
		else
			-1
		then
	        r> close ;

	: (seek) ( whence offset handle ) 
		-rot 0 rot
		SetFilePointer ( handle off offhigh whence )
		;
	reveal stat
	reveal delete
	reveal rename
	reveal mtime
        reveal (seek)
loc;
[THEN]

: appdir appfile 'ps -chop ;  | MM-070510
: appname appdir + 1+ zcount   ;  | MM-070510


| : seek ( offs h -- newoffs ) >r 0 swap r> (seek) drop ;  | MM-090920
| : tell ( fh -- offs ) 1 0 rot (seek) ;                   |

0 [IF] | MM-070906
: bl2sep ( a u -- a u ) | replace bl with pathsep   MM-060818
         dup 0if exit then 2dup begin 2dup + dup c@ 32 = 
         if 'ps swap c! else drop then 1- dup 0until 2drop ;
: bl2ps ( a u -- a u ) | replace bl with pathsep   MM-070906
         | new definition to replace  begin ... 0until loop
         dup 0if exit then
         2dup 0 do dup c@ bl = if 'ps over c! then 1+ loop drop ;
[THEN]
: bl2ps ( a u -- a u ) | replace bl with pathsep   MM-090101
        2dup 0 ?do dup c@ bl = if 'ps over c! then 1+ loop drop ;

| MM-090920  (seek) seek and tell commented out
| MM-090920  delete -> delete-file , rename -> rename-file
| MM-090808  open-file moved to the core
| MM-090307  DO LOOP -> do loop ...
| MM-090213  ioctl changed to return an ior-value on the stack and no longer
|            in the global variable ioerr.
| MM-090204  create-file added
| MM-090125  r/o r/w, w/o , open-file added
| MM-090103  :: -> :noname
| MM-090101  do loop ... -> DO LOOP ...
| MM-080530  Reva repeat -> begin , Reva while -> 0until
| MM-080322  bug fix in rename ( wrong number of arguments foe syscall )
| MM-080216  ioctl
| MM-080206  bl2sep -> bl2ps
| MM-080205  pathsep -> 'ps
| MM-070309  libdirx removed
| MM-070510  ;; -> exit
| MM-070906  bl2sep rewritten
