\  Array/methods.4th
\ -----------------------------------------------------------------------------
\  Array methods             OOP Library for csp4th                  MM-060901
\ -----------------------------------------------------------------------------
\
\                    Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
 
\  self seal  \ MM-080208  An array should be sealed by the programer
  
  m: init (C <array class> -> .. ) (S u oid -- )
     >r self up units * r> self init
   ;

  self up units
 
  dup 1 = [IF]  macro : seek ;  [THEN]
 
  dup 2 = [IF]  : seek >r 2* r> ;  [THEN]
 
  dup 4 = [IF]  : seek >r 2* 2* r> ;  [THEN]
 
  dup 4 = over 1 = or over 2 = or not [IF] \ units <> 1, 2 or 4
 
      : seek >r self up units * r> ;  [THEN]
 
  drop
 
  private

  m: (of) (C <array-class> -> <element-class> )
          (S i oid.Array -- oid.element )
     self seek (of)  self up 
  ;
 
  public

  m: i? (C <array-class> -> .. ) (S i oid -- ? )
     self seek i?
   ;
 
 
  m: of (C <array-class> -> <element-class> )
        (S i oid.Array -- oid.element )
     self seek of  self up 
   ;
 
  hide seek
 
  m: size (C <array-class> -> .. ) (S oid -- u )
     self size self up units / 
   ;
 
  self up [DEFINED] ? [IF]
 
    m: ? (C <array-class> -> .. ) (O -- )
       this size 0 ?do cr i 3 .r  ." : " i this (of) ? loop cr
     ;
 
  [THEN]
\ -----------------------------------------------------------------------------
\ Last revision: MM-090307  DO LOOP -> do loop ...
\                MM-090101  do loop ... -> DO LOOP ... ANS
\                MM-080409  stack diagrams
