\  Buffer.4th
\ -----------------------------------------------------------------------------
\  class Buffer         OOP Module for csp4th                        MM-060901
\ -----------------------------------------------------------------------------
\
\                  Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------

  needs Pointer
 
  oop definitions
 
  class Buffer  Buffer definitions  Pointer inherit  self seal
 
  m: size (S oid -- u )
     self @ cell- @
   ;
 
  \ body of the pointer : |buffer-addr |
  \ body of the buffer  : |size |buffer memory|

  m: init (O u -- )
     this new?
     if   \ buffer is not initialized, do it now
       dup , here this init allot
     else \ buffer is already initialized, check if size is unchanged
       this size  2dup <>if
         ." Error on buffer initialization, old size = " .
         ." ,new size = " . -1 throw
       then
       2drop
     then
   ;

  m: i? (S i oid -- flag ) \ geändert MM-080409
     >r 1+ 1 r> self size between
   ;

  private
 
  : ?i (S i oid -- )
    self i? 0if ." of ?  Index is out of range   " -1 throw then
  ;
 
  m: (of) (S i oid -- a )
     @ +
   ;
 
  public
 
  m: of (S i oid -- addr )
     2dup self ?i (of) ;
   ;

  oop definitions
\ -----------------------------------------------------------------------------
\ Last revision: MM-081005  buffer re-initialisation revised, not changed
