
  needs GtkToplevel
  needs GtkLabel
  needs GTimeout
  needs os time&date
  needs String
\ ------------------------------------------------------------------------------
\  csp4th OOP                GTimeout example.1                       MM-060901
\ ------------------------------------------------------------------------------
\                    Copyright (C) 2008 Manfred Mahlow
\
\                    This code is in the public domain.
\ ------------------------------------------------------------------------------

  oop definitions

  class GtkOsTime  GtkOsTime definitions   GtkLabel inherit

   GTimeout this timer
   
   self seal

   m: update ( oid -- )
      >r " <span size=\"64000\" color=\"darkgray\">"
         os time @ hh:mm:ss 0 join  " </span>" 0 join
      r> self text ! ;

   :noname ( oid -- true ) self update true ; 1 50 cb cb.timer ( oid -- true )

   :noname ( wid oid -- ) self timer remove ; 2 20 cb cb.destroy

   m: init (S msec oid -- wid )
           (O oid -- ) (S msec -- wid )
      " hh:mm:ss" this init >r   this use-markup on  6 this xpad !
       this cb.timer this timer init
      " destroy" this cb.destroy swap this signal connect drop r>
    ;

   hide cb.timer  hide cb.destroy

  GTimeout definitions

  private vocabulary example.1  self example.1 definitions

  GtkToplevel new window 
  GtkOsTime   new  time

  :noname ( wid 0 -- ) gtk main_quit ;  2 20 cb cb.destroy

  : run ( -- )

       \ 0 0 gtk init

        " GTimeout Example 1" window init  6 window border-width !

        100 time init window add

        " destroy" cb.destroy 0 window signal connect drop

        window show_all

        gtk pending
  
  ;

  hide cb.destroy

  run term? [IF] ?? [ELSE] gtk main bye [THEN]

\ ------------------------------------------------------------------------------
\ Last revision: MM-090510  also removed
\                MM-090103  :: -> :noname
\                MM-080803  show all -> show_all , gtk main -> gtk main_quit
