#! /usr/local/bin/csp4th

   needs GtkToplevel
   needs GtkHBox
   needs GtkImage
   needs GtkImageFromFile
   needs GtkVBox
   needs GtkLabel
   needs GtkVScale
   needs GdkPixbuf
 \ -----------------------------------------------------------------------------
 \  csp4th :  GdkPixbuf Example 1                                     MM-080314
 \ -----------------------------------------------------------------------------

   GdkPixbuf definitions

   private vocabulary example.1  self example.1 definitions  also gtk api

   GtkToplevel   new window
   GtkHBox       new  hbox.1
   GtkImage      new   image
   GtkVBox       new   vbox.1
   GtkLabel      new    label.1
   GtkVScale     new    scale.1
   GtkVBox       new   vbox.2
   GtkLabel      new    label.2
   GtkVScale     new    scale.2

   GdkPixbuf new pixbuf.1
   GdkPixbuf new pixbuf.2

   :noname ( wid data -- ) pixbuf.1 free gtk main_quit ;  2 20 cb destroy

   :noname ( wid data -- )
      pixbuf.1 new? if exit then
      scale.1 @ df>s >r
      pixbuf.1 width @ r@ 100 */ 0 max
      pixbuf.1 height @ r> 100 */ 0 max
      pixbuf.1 hyper scale  pixbuf.2 init
      scale.2 @ df>sf false pixbuf.2 saturate  image pixbuf ! pixbuf.2 free
   ; 2 20 cb 'update 

   :noname ( wid df.value data -- )
      " --- %" 1+ dup allocate if ." memory allocation error " -1 throw then
      dup >r swap move drop df>s nip 3 (.r) r@ swap move r>
    ; 4 20 cb 'format%

   m: run ( -- )

      " GtkPixbuf Example 1" window init

        12 window border-width !

        " destroy" destroy 0 window signal connect drop


      hbox.1 init  window add

      " " image from-file init  true true 6 hbox.1 pack_start

      300 dup image width-request !  image height-request ! 


      vbox.1 init  false false 12 hbox.1 pack_start

      100.0 5.0 200.0 1.0 10.0 0.0 scale.1 init  vbox.1 pack_end_defaults

         scale.1 inverted yes  scale.1 value-pos bottom

         " format-value" 'format% 0 scale.1 signal connect drop

         " value-changed" 'update 0 scale.1 signal connect drop


      " _Zoom" label.1 init  0 0 0 vbox.1 pack_start

         label.1 use-underline yes

         scale.1 wid label.1 mnemonic-widget !

         scale.1 update-policy discontinous

         0 scale.1 digits !


      vbox.2 init  false false 12 hbox.1 pack_start

      1.0 0.0 5.0 0.01 0.1 0.0 scale.2 init  vbox.2 pack_end_defaults

         scale.2 inverted yes  scale.2 value-pos bottom

         2 scale.2 digits !

         scale.2 update-policy discontinous

         " value-changed" 'update 0 scale.2 adjustment signal connect drop


      " _Sättigung" label.2 init  0 0 0 vbox.2 pack_start

         label.2 use-underline yes

         scale.2 wid label.2 mnemonic-widget !


      window show_all

   \  " GdkPixbuf/dscn0561.jpg" /?/ pixbuf.1 from file init  \ MM-090924
      " GdkPixbuf/dscn0561.jpg" /?/ pixbuf.1 from-file init

      image width-request @  100
      pixbuf.1 width @  pixbuf.1 height @ max */ 100 min s>df

      scale.1 adjustment value !

    ;

   previous run term? [IF] ?? [ELSE] gtk main bye [THEN]
 \ -----------------------------------------------------------------------------
 \ Last revision: MM-090924  from file --> from-file
 \                MM-090306  :: -> :noname
 \                MM-090123  adapted to new ANS conform allocate
 \                MM-080803  gtk quit -> gtk main_quit , show all -> show_all
 \                           pack defaults end -> pack_end_defaults
 \                           pack start -> pack_start
