
  needs GtkContainer
\ ------------------------------------------------------------------------------
\  class GtkBox              OOP Module for csp4th                    MM-060901
\ ------------------------------------------------------------------------------
\                      Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------
  gtk api definitions

  libgtk import gtk_box_pack_start ( box widget expand fill padding -- )
  libgtk import gtk_box_pack_end   ( box widget expand fill padding -- )
  libgtk import gtk_box_pack_start_defaults ( box widget -- )
  libgtk import gtk_box_pack_end_defaults   ( box widget -- )

  class GtkBox  GtkBox definitions  GtkContainer inherit  self seal

   m: homogeneous ( oid -- oid a u ) self " homogeneous" gboolean ;

   m: spacing ( oid -- oid a u ) self " spacing" gint ;


   m: s/e (O wid expand fill padding -- wid' wid expand fill padding )
       >r >r >r >r  \? cr ." packing widget " r@ . ." to "
       this wid  \? dup .
       r> r> r> r> ;

   m: pack_start ( wid expand fill padding oid -- )
          self s/e gtk_box_pack_start ;

   m: pack_end ( wid expand fill padding oid -- )
          self s/e gtk_box_pack_end ;

   hide s/e


   m: pack_start_defaults ( wid oid -- )
          \? cr ." packing widget " over . ." to "
          self wid (? dup . ) swap gtk_box_pack_start_defaults ;

   m: pack_end_defaults ( wid oid -- )
          \? cr ." packing widget " over . ." to "
          self wid (? dup . ) swap gtk_box_pack_end_defaults ;

  oop
\ ------------------------------------------------------------------------------
\ Last revision: MM-0800803  pack start -> pack_start
\                            pack end -> pack_end
\                            pack defaults start -> pack_start_defaults
\                            pack defaults end   -> pack_end_defaults
