#! /usr/local/bin/csp4th

   needs GtkToplevel
   needs GtkVBox
   needs GtkButton
   needs GtkImageFromStock
   needs GtkTooltips
\ ------------------------------------------------------------------------------
\  csp4th OOP                GtkButton example.1                      MM-070401
\ ------------------------------------------------------------------------------
\                    Copyright (C) 2008 Manfred Mahlow
\
\                    This code is in the public domain.
\ ------------------------------------------------------------------------------

   GtkButton definitions

   private vocabulary example.1  self example.1 definitions

   GtkToplevel new window
   GtkVBox     new  vbox
   GtkButton   new   button.1
   GtkButton   new   button.2
   GtkButton   new   button.3
   GtkButton   new   button.4
   GtkButton   new   button.5
   GtkImage    new    image

   GtkTooltips new tips


   :noname ( wid data -- )
           2drop  tips destroy  gtk main_quit ; 2 20 cb cb.destroy

   :noname ( wid data -- )
           nip cr ." Button " . ." was activated." cr ; 2 20 cb cb.click

   : run ( -- )

      " GtkButton Examples" window init  window position none

      6 window border-width !  100 window width-request !

      " destroy" cb.destroy 0 window signal connect drop

      vbox init window add   6 vbox spacing !

         " gtk-ok" button.1 init vbox pack_start_defaults
       " Button 2" button.2 init vbox pack_start_defaults
      " _Button 3" button.3 init vbox pack_start_defaults
               " " button.4 init vbox pack_start_defaults
               " " button.5 init vbox pack_start_defaults

      " gtk-open" image from-stock button-size init button.5 add

      " clicked" cb.click 1 button.1 signal connect drop
      " clicked" cb.click 2 button.2 signal connect drop
      " clicked" cb.click 3 button.3 signal connect drop
      " clicked" cb.click 4 button.4 signal connect drop
      " clicked" cb.click 5 button.5 signal connect drop

      tips init

      " button.1 with icon and label from stock" button.1 wid tips !
      " button.2 with user defined label" button.2 wid tips !
      " button.3 with user defined label with mnemonic" button.3 wid tips !
      " button.4 created without any child widget" button.4 wid tips !
      " button.5 with an image from stock as child widget" button.5 wid tips !
 
       window show_all

   ;

   hide cb.destroy  hide cb.click

   run term? [IF] ?? [ELSE] gtk main bye [THEN]

 \ -----------------------------------------------------------------------------
 \ Last revision: MM-090103  :: -> :noname
\                 MM-080803  show all -> show_all , gtk main -> gtk main_quit
