
  needs GtkBin
\ ------------------------------------------------------------------------------
\  class GtkComboBoxText      OOP Module for reva-cspForth            MM-070825
\ ------------------------------------------------------------------------------
\                        Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------
  gtk api definitions

   libgtk import gtk_combo_box_new_text ( -- *widget )
   libgtk import gtk_combo_box_append_text ( *widget *text -- )
   libgtk import gtk_combo_box_prepend_text ( *widget *text -- )
   libgtk import gtk_combo_box_remove_text ( position *widget -- )
   libgtk import gtk_combo_box_get_active_text ( *widget -- *char )

  oop definitions  gtk api

  class GtkComboBoxText  GtkComboBoxText definitions  GtkBin inherit  self seal

    m: active ( oid -- oid a u ) self " active" gint ;

    m: activate ( u oid -- ) self active ! ;

    m: @ ( oid -- a.text u.text )
       \? cr ." getting active text from GtkComboBox "
       self wid (? dup . ) gtk_combo_box_get_active_text zcount ;

    m: ? ( oid -- ) self @ type ;

    m: append ( a.text u.text oid -- )
       >r \? cr ." appending text to GtkComboBox "
       zt r> self wid (? dup . ) swap gtk_combo_box_append_text ;

    m: prepend ( a.text u.text oid -- )
       >r \? cr ." prepending text to GtkComboBox "
       zt r> self wid (? dup . ) swap gtk_combo_box_prepend_text ;

    m: remove ( position oid -- )
       \? cr ." removing text from GtkComboBox "
       self wid (? dup . ) swap gtk_combo_box_remove_text ;

    m: init ( oid -- wid ) \? cr ." creating GtkComboBoxText "
       gtk_combo_box_new_text swap GtkObject init ;

    m: split (O a u c -- )
       >r begin r@ split >r this append r> 0until r> drop ;

   oop definitions
\ ------------------------------------------------------------------------------
\ Last revision: MM-080531  Reva repeat while -> begin 0until
\                MM-080413  (O
