
  needs GtkToplevel
  needs GtkHBox
  needs GtkVBox
  needs GtkEventBox Array
  needs GtkImage Array
  needs GtkImageFromStock
  needs GtkImageFromFile
  needs GtkLabel
  needs GtkTooltips

  needs for,next
\ -----------------------------------------------------------------------------
\  GtkImage Example 3 for csp4th                                     MM-070406
\ -----------------------------------------------------------------------------

  GtkImage definitions

  private vocabulary example.3  self example.3 definitions

  GtkToplevel       new window
  GtkVBox           new  vbox
  GtkHBox           new   hbox
  GtkEventBox Array new    events
  GtkTooltips       new    tips
  GtkLabel          new   info

  :noname ( wid 0 -- ) tips destroy gtk main_quit ; 2 20 cb cb.destroy

  : run ( -- )
 
    " GtkImage Example 3" window init  6 window border-width !

    vbox init  3 vbox spacing !  window add

    hbox init  3 hbox spacing !  vbox pack_start_defaults

    7 dup events init

      0 do i events of init  hbox pack_start_defaults loop

    " gtk-dialog-info" GtkImage from-stock menu-size item
    " gtk-dialog-info" GtkImage from-stock small-toolbar-size item
    " gtk-dialog-info" GtkImage from-stock large-toolbar-size item
    " gtk-dialog-info" GtkImage from-stock button-size item
    " gtk-dialog-info" GtkImage from-stock dnd-size item
    " gtk-dialog-info" GtkImage from-stock dialog-size item
    " icons/butterfly.png" /?/ GtkImage from-file item

     events size for r@ events of add next

    " Place the mouse pointer over an image to see its tooltip." info init

    0 0 0 vbox pack_start

    tips init

    " Image 0 'dialog-info' from stock, menu-size."          
    " Image 1 'dialog-info' from stock, small-toolbar-size." 
    " Image 2 'dialog-info' from stock, large-toolbar-size."  
    " Image 3 'dialog-info' from stock, button-size."        
    " Image 4 'dialog-info' from stock, dnd-size."           
    " Image 5 'dialog-info' from stock, dialog-size."        
    " Image 6 from file" " icons/butterfly.png" /?/ bl join

    events size for r@ events of wid tips ! next
 
    " destroy" cb.destroy 0 window signal connect drop

    window show_all

  ;

  hide cb.destroy

  run term? [IF] ?? [ELSE] gtk main bye [THEN]
\ -----------------------------------------------------------------------------
\ Last revision: MM-090307  DO LOOP ... -> do loop ...   FOR NEXT -> for next
\                MM-090306  :: -> :noname
\                MM-090101  do loop ... -> DO LOOP ... ANS
\                           DO ... -1 +loop replaced with for ... next
\                MM-080803  pack defaults start -> pack_start_defaults
\                           pack start -> pack_start
\                           gtk quit -> gtk main_quit , show all -> show_all
\                MM-080531 Reva repeat while -> begin 0until
