
   needs String
   needs GtkImage
\ ------------------------------------------------------------------------------
\  class GtkImageFromStock      OOP Module for csp4th                 MM-080411
\ ------------------------------------------------------------------------------
\                  Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------
   gtk api definitions

    libgtk import gtk_image_new_from_stock ( *stock-id *size -- *widget )

    libgtk import gtk_image_set_from_stock ( *widget *stock-id *size -- )

   GtkImage definitions  gtk api

   class from-stock  self from-stock definitions  GtkImage inherit

   self seal

    m: ?size (S size -- size )
          dup 0 < over -7 > and 
          0if ." ? Valid icon size missing.  " -1 throw then abs ;

    m: item ( a u size -- wid )
            >r \? cr ." creating GtkImage " 2dup type ."  from stock "
            zt r> self ?size gtk_image_new_from_stock ;

    m: init ( a u oid size -- wid )
            swap >r self item r> GtkObject init ;

    m: ! ( a u oid size -- )
         swap >r >r  \ self gtk-img \ MM-070827
         \? cr ." setting image " 2dup type ."  from stock"
         zt r> self ?size r> self wid \? ."  on " dup .
         -rot gtk_image_set_from_stock ;

0 [IF] \ MM-081227
    m: init ( a u size oid -- wid )
            >r >r  \ self gtk-img \ MM-070827
            \? cr ." creating GtkImage " 2dup type ."  from stock "
            zt r> self ?size gtk_image_new_from_stock r> GtkObject init ;

    m: ! ( a u size oid -- )
         >r >r  \ self gtk-img \ MM-070827
         \? cr ." setting image " 2dup type ."  from stock"
         zt r> self ?size r> self wid \? ."  on " dup .
         -rot gtk_image_set_from_stock ;

    : is ( n -- ) create , does> @ swap ;

    self -1 is menu-size           \ menu icon size (16x16)
         -2 is small-toolbar-size  \ small toolbar icon size (18x18)
         -3 is large-toolbar-size  \ large toolbar icon size (24x24)
         -4 is button-size         \ button icon size (20x20)
         -5 is dnd-size   \ icon size for drag and drop objects (32x32)
         -6 is dialog-size  \ dialog icon size (48x48)
    .. hide is   
[THEN]

    hide ?size

    -1 constant menu-size           \ menu icon size (16x16)
    -2 constant small-toolbar-size  \ small toolbar icon size (18x18)
    -3 constant large-toolbar-size  \ large toolbar icon size (24x24)
    -4 constant button-size         \ button icon size (20x20)
    -5 constant dnd-size   \ icon size for drag and drop objects (32x32)
    -6 constant dialog-size  \ dialog icon size (48x48)

    oop definitions
\ ------------------------------------------------------------------------------
\  Last revision: MM-081227  item  factored out of  init
\                            init ( a u size oid -- wid ) ->
\                            init ( a u oid size -- wid )
\                            ! ( a u size oid -- ) -> ! ( a u oid size -- ) 
\                 MM-080420  self ( -> self \
