#! /usr/local/bin/csp4th

  needs GtkToplevel
  needs GtkVBox
  needs GtkLabel
  needs GtkFrame
\ ------------------------------------------------------------------------------
\  csp4th OOP                GtkLabel example.2                       MM-060901
\ ------------------------------------------------------------------------------
\                    Copyright (C) 2008 Manfred Mahlow
\
\                    This code is in the public domain.
\ ------------------------------------------------------------------------------

  GtkLabel definitions

  private vocabulary example.2  self example.2 definitions

  GtkToplevel new window
  GtkVBox     new  vbox
  GtkLabel    new   label.0
  GtkFrame    new   frame.1
  GtkLabel    new    label.1
  GtkFrame    new   frame.2
  GtkLabel    new    label.2
  GtkFrame    new   frame.3
  GtkLabel    new    label.3
  GtkFrame    new   frame.4
  GtkLabel    new    label.4
  GtkFrame    new   frame.5
  GtkLabel    new    label.5
  
  :noname ( wid data -- ) gtk main_quit ;  2 20 cb cb.destroy

  : run ( -- )

      " GtkLabel Example 2" window init  \ window position center

      2 window border-width !    450 350 window resize

      vbox init  vbox homogeneous yes  5 vbox spacing !  window add

      " " label.0 init  label.0 use-markup on  vbox pack_start_defaults

      " <span weight=\"bold\" size=\"large\"> GtkLabel Alignment </span>"
      label.0 text !

      " " frame.1 init vbox pack_start_defaults
      " " frame.2 init vbox pack_start_defaults
      " " frame.3 init vbox pack_start_defaults
      " " frame.4 init vbox pack_start_defaults
      " " frame.5 init vbox pack_start_defaults

      " label.1 : default alignment, xalign=0.5=center yalign=0.5=center" label.1 init frame.1 add
      " label.2 : xalign=0.0=left yalign=0.5=center" label.2 init frame.2 add
      " label.3 : xalign=1.0=right yalign=0.5=center" label.3 init frame.3 add
      " label.4 : xalign=0.0=left yalign=0.0=top" label.4 init frame.4 add
      " label.5 : xalign=1.0=right yalign=1.0=bottom" label.5 init frame.5 add


      label.2 xalign left
      label.3 xalign right
      %0 dup ( 0.0 0.0 -- ) label.4 alignment !
      %00111111100000000000000000000000 dup ( 1.0 1.0 -- ) label.5 alignment !

      " destroy" cb.destroy 0 window signal connect drop

      window show_all

   ;

   hide cb.destroy

  run term? [IF] ?? [ELSE] gtk main bye [THEN]

\ ------------------------------------------------------------------------------
\ Last revision: MM-090306  :: -> :noname
\                MM-080803  pack defaults start -> pack_start_defaults
\                           gtk quit -> gtk main_quit , show all -> show_all
