#! /usr/local/bin/csp4th

  needs GtkToplevel
  needs GtkVBox
  needs GtkLabel Array
  needs GtkFrame Array
\ ------------------------------------------------------------------------------
\  csp4th OOP                 GtkLabel example.3                      MM-060901
\ ------------------------------------------------------------------------------
\                    Copyright (C) 2008 Manfred Mahlow
\
\                    This code is in the public domain.
\ ------------------------------------------------------------------------------

  GtkLabel definitions

  private vocabulary example.3  self example.3 definitions

  GtkToplevel    new window
  GtkVBox        new  vbox
  GtkLabel       new   label
  GtkLabel Array new   labels
  GtkFrame Array new   frames
  
  :noname ( wid data -- ) gtk main_quit ;  2 20 cb cb.destroy

  : run ( -- )

      " GtkLabel Example 3" window init  \ window position center

      2 window border-width !    450 350 window resize

      vbox init  vbox homogeneous yes  5 vbox spacing !  window add

      " " label init  label use-markup on  vbox pack_start_defaults

      " <span weight=\"bold\" size=\"large\"> GtkLabel Alignment </span>"
      label text !

      5 frames init  frames size labels init

      frames size 0 do " " i frames of init vbox pack_start_defaults loop

      " label 0 : default alignment, xalign=0.5=center yalign=0.5=center"
        0 labels of init  0 frames of add
      " label 1 : xalign=0.0=left yalign=0.5=center"
        1 labels of init  1 frames of add
      " label 2 : xalign=1.0=right yalign=0.5=center" 
        2 labels of init  2 frames of add
      " label 3 : xalign=0.0=left yalign=0.0=top"
        3 labels of init  3 frames of add
      " label 4 : xalign=1.0=right yalign=1.0=bottom"
        4 labels of init 4 frames of add


      1 labels of xalign left
      2 labels of xalign right
      %0 dup ( 0.0 0.0 -- ) 3 labels of alignment !
      %00111111100000000000000000000000 dup ( 1.0 1.0 -- ) 4 labels of alignment !

      " destroy" cb.destroy 0 window signal connect drop

      window show_all

   ;

   hide cb.destroy

   run term? [IF] ?? [ELSE] gtk main bye [THEN]
\ ------------------------------------------------------------------------------
\  Last revision: MM-090307  DO LOOP ... -> do loop ...
\                 MM-090306  :: -> :noname
\                 MM-090101  do loop ... -> DO LOOP ... ANS
\                 MM-080803  pack defaults start -> pack_start_defaults
\                            gtk quit -> gtk main_quit , show all -> show_all
