
  needs Cell Array
  needs gtk api
  needs GtkTreeIter
\ ------------------------------------------------------------------------------
\  class GtkListStore        OOP Module for csp4th                    MM-061229
\ ------------------------------------------------------------------------------
\                     Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------

  gtk api definitions

   libgtk import gtk_list_store_newv ( #columns *types -- *list_store )

   libgtk import gtk_list_store_append ( *list_store *iter -- )

   libgtk import gtk_list_store_set ( *list_store *iter store-col# *value -1 -- )

   libgtk import gtk_list_store_set_value ( *list_store *iter store-col# *value -- )

   libgtk import gtk_list_store_clear ( *list_store -- )

   libgtk import gtk_tree_model_get_value ( *list_store *iter col# *value -- )

\   libgtk import g_type_init ( -- )

\   libgtk import g_type_name ( type -- *name )

\   libgtk import g_type_from_name ( *name -- type )

\   libgtk import g_type_fundamental_next ( -- type )

\ type-values are defined in /usr/include/glib-2.0/gtype.h
\
\ 2 constant G_TYPE_FUNDAMENTAL_SHIFT
\ : G_TYPE_MAKE_FUNDAMENTAL ( u8 -- type ) G_TYPE_FUNDAMENTAL_SHIFT << ;


0 [IF]
0 0
4 -1210721893 4 void
8 -1210721868 10 GInterface
12 -1210712681 5 gchar
16 -1210712641 6 guchar
20 -1210712613 8 gboolean
24 -1210712581 4 gint          G_TYPE_INT
28 -1210712557 5 guint
32 -1210712531 5 glong
36 -1210712505 6 gulong
40 -1210712477 6 gint64
44 -1210712449 7 guint64
48 -1210739258 5 GEnum
52 -1210739223 6 GFlags
56 -1210712419 6 gfloat
60 -1210712391 7 gdouble
64 -1210712361 10 gchararray   G_TYPE_STRING
68 -1210712328 8 gpointer
72 -1210741620 6 GBoxed
76 -1210733385 6 GParam
80 -1210741628 7 GObject
84 0
[THEN]

  24 constant G_TYPE_INT
  64 constant G_TYPE_STRING


  oop definitions  gtk api

  class GtkListStore  GtkListStore definitions   Pointer inherit

  private GtkTreeIter this iter
  public  Cell this row

  self seal

   m: init (O col-type.1 ... col-type.n  #cols -- lsid )
        dup 0if ." list store init : columns missing  " -1 throw then
        dup >r cells pad + begin cell- dup >r ! r> dup pad = until
        r> swap gtk_list_store_newv dup this init ;  

   m: free ( oid -- ) off ;

   m: append (O -- )
        \? cr ." appending node to list store "
        this @ (? dup . ) this iter dup this row ! gtk_list_store_append ;

   m: clear ( oid -- )
            self @ gtk_list_store_clear ;

   iface value
   iface text

   self value definitions

   m: ! (O value column -- )
        \? cr ." setting list store value "
        swap >r >r this up @ this up row @ r> r> -1 gtk_list_store_set ;

   m: @ (O column -- a u )
        this up @ this up row @ rot  0 0 pad 2! pad gtk_tree_model_get_value 
        pad @ #24 =if pad cell+ @ (.) exit then
        pad @ #64 =if pad cell+ @ zcount exit then
        ." Unknown data type.  " -1 throw ;

   self up text definitions

   m: ! (O a.text u.text column -- )
        \? cr ." setting list store value "
        >r zt >r this up @ this up row @ r> r> swap -1 gtk_list_store_set ;

   m: @ (O column -- a )
        this up @ this up row @  0 0 pad 2! pad gtk_tree_model_get_value 
        pad @ #64 <>if ." String value missing.  " -1 throw then
        pad cell+ @ zcount ;

  self up definitions  oop
\ ------------------------------------------------------------------------------
\ Last revision: MM-080602  code rewritten to use an internal iter
\                MM-080531  0until -> until
