#! /usr/local/bin/csp4th

   needs GtkToplevel
   needs GtkVBox
   needs GtkButton
   needs GtkMenu
   needs GtkMenuBar
   needs GtkMenuItem
\ ------------------------------------------------------------------------------
\  csp4th OOP                 GtkMenu example.1                       MM-080316
\ ------------------------------------------------------------------------------
\                     Copyright (C) 2008 Manfred Mahlow
\
\                     This code is in the public domain.
\ ------------------------------------------------------------------------------
   GtkMenu definitions

   private vocabulary example.1  self example.1 definitions

   GtkToplevel new window
   GtkVBox     new  vbox
   GtkMenuBar  new   menu-bar
   GtkMenuItem new   root-menu
   GtkMenu     new    menu
   GtkMenuItem new     m1
   GtkMenuItem new     m2
   GtkButton   new   button


   :noname ( wid data -- ) 2drop gtk main_quit ; 2 20 cb 'destroy

   :noname ( wid data -- ) nip cr ." m" . ."  activated " ; 2 20 cb 'activated

   :noname ( wid menu.oid -- ) nip 0 swap GtkMenu popup true ; 2 20 cb 'clicked

   : run ( -- )
         " GtkMenu Example 1" window init   300 window default-width !

         vbox init window add

         menu-bar init  false false 2 vbox pack_start

         " Root Menu" root-menu init  menu-bar append

         menu init  root-menu submenu !

         " m1" m1 init  menu append
         " m2" m2 init  menu append

         " activate" 'activated 1 m1 signal connect drop
         " activate" 'activated 2 m2 signal connect drop

         " menu" button init  false false 2 vbox pack_end

         " clicked" 'clicked menu oid button signal connect drop

         " destroy" 'destroy 0 window signal connect drop

         window show_all
    ;


   run term? [IF] ?? [ELSE] gtk main bye [THEN]

 \ -----------------------------------------------------------------------------
 \ Last revision: MM-090306  :: -> :noname
\                 MM-081227  GtkMenu popup is now called with two parameters
\                 MM-080803  gtk quit -> gtk main_quit , show all -> show_all
 \                           pack start -> pack_start , pack end -> pack_end









