  needs GtkCheckButton
\ ------------------------------------------------------------------------------
\  class GtkRadioButton        OOP Module for csp4th                  MM-070323
\ ------------------------------------------------------------------------------
\                        Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------
  gtk api definitions

   libgtk import gtk_radio_button_new ( 0 -- *widget )
   libgtk import gtk_radio_button_new_from_widget ( *group -- *widget )

   libgtk import gtk_radio_button_new_with_mnemonic ( 0 *label -- *widget )
   libgtk import gtk_radio_button_new_with_mnemonic_from_widget ( *group *label -- *widget )

  oop definitions  gtk api

  class GtkRadioButton  GtkRadioButton definitions   GtkCheckButton inherit

  self seal

   m: init (S wid|0 a u oid -- wid )
      >r \? cr ." creating GtkRadioButton "
      if \ init with label
         over if \ init with mnemonic from widget
           gtk_radio_button_new_with_mnemonic_from_widget
         else \ init with mnemonic
           gtk_radio_button_new_with_mnemonic
         then
      else \ no label
        drop dup if \ init with widget
          gtk_radio_button_new_from_widget
        else \ init without widget
          gtk_radio_button_new
        then
      then r> GtkObject init ;

      \ a u = string to be used as button label text
      \
      \       a u ( eg. " _Ende" ) = a button with label a u is created, with
      \                              a mnemonic, if a u contains an underscore
      \
      \       a 0 = a button without a label is created

\  m: active ( oid -- ) self " active" (gboolean) ;

  oop
\ ------------------------------------------------------------------------------
\ Last revision: MM-080104
