
  needs GtkContainer
\ ------------------------------------------------------------------------------
\  class GtkTable            OOP Module for csp4th                    MM-060525
\ ------------------------------------------------------------------------------
\                     Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------

  gtk api definitions

   %01 0 lshift constant GTK_EXPAND

   %01 1 lshift constant GTK_SHRINK

   %01 2 lshift constant GTK_FILL

   libgtk import gtk_table_new ( rows columns homogeneous -- *widget )

   libgtk import gtk_table_attach ( *table *child left right top bot xopts yopts xpad ypad -- )

   libgtk import gtk_table_attach_defaults ( *table *child left right top bot -- )

\   libgtk import gtk_table_set_col_spacing ( *table col space -- )

   libgtk import gtk_table_resize ( *table rows cols -- )


  oop definitions  gtk api

  class GtkTable  GtkTable definitions  GtkContainer inherit  self seal

   m: init (S oid -- wid )
      >r (? cr ." creating GtkTable " ) 
      0 dup 0 gtk_table_new r> self init ;  \ rows=cols=0, homogeneous=false

   m: resize ( rows cols oid -- )
             self wid -rot gtk_table_resize ;

   m: attach (O wid left right top bot xopts yopts xpad ypad -- )
        \? cr ." attaching " 8 pick .  ." to table "
        >r >r >r >r >r >r >r >r >r this wid (? dup . )
        r> r> r> r> r> r> r> r> r> gtk_table_attach ;

   m: attach_defaults (O wid left right top bot -- )
              \? cr ." attaching " 4 pick . ." with defaults to table "
              >r >r >r >r >r this wid (? dup . ) r> r> r> r> r>
              gtk_table_attach_defaults ;


   m: n-columns ( oid -- oid a u  ) self " n-columns" guint ;

   m: n-rows ( oid -- oid a u  ) self " n-rows" guint ;

   m: homogeneous ( oid -- oiid a u ) self " homogeneous" gboolean ;

   m: column-spacing ( oid -- oid a u ) self " column-spacing" guint ;

   m: row-spacing ( oid -- oid a u ) self " row-spacing" guint ;

   oop definitions
\ ------------------------------------------------------------------------------
\ Last revision: MM-081113  << -> lshift
\                MM-080805  defaults attach -> attach_defaults
\                MM-080416  (O
