
  needs GtkToplevel
  needs GtkTable
  needs GtkLabel
  needs GtkEntry
\ ------------------------------------------------------------------------------
\  GtkTable example 1 for csp4th                                      MM-061209
\ ------------------------------------------------------------------------------
\                      Copyright (C) 2008 Manfred Mahlow
\
\                      This code is in the public domain.
\ ------------------------------------------------------------------------------

  GtkTable definitions

  private vocabulary example.1  self example.1 definitions

  :noname ( wid data -- ) gtk main_quit ;  2 10 cb cb.destroy

  GtkToplevel new window
  GtkTable    new  table
  GtkLabel    new   label.1
  GtkLabel    new   label.2
  GtkLabel    new   label.3
  GtkEntry    new   entry.1
  GtkEntry    new   entry.2
  GtkEntry    new   entry.3

  : run ( -- )

    " GtkTable Example" window init  \ window position center

    250 window width-request !

    " destroy" cb.destroy 0 window signal connect drop

    table init window add

    10 table column-spacing !    6 table border-width !

    " Label 1" label.1 init 0 1 0 1  %100 0 0 0 table attach
           " " entry.1 init 1 2 0 1  %111 0 0 0 table attach

    " Label 2" label.2 init 0 1 1 2  %100 0 0 0 table attach
           " " entry.2 init 1 2 1 2  %111 0 0 0 table attach

    " Label 3" label.3 init 0 1 2 3  %100 0 0 0 table attach
           " " entry.3 init 1 2 2 3  %111 0 0 0 table attach

    80 label.1 width-request !

    label.1 xalign left
    label.2 xalign center
    label.3 xalign right

    window show_all

  ;

  hide cb.destroy

  run term? [IF] ?? [ELSE] gtk main bye [THEN]

\ ------------------------------------------------------------------------------
\ Last revision: MM-090306  :: -> :noname
\                MM-080803  gtk quit -> gtk main_quit , show all -> show_all
