
  needs GtkToplevel
  needs GtkHBox
  needs GtkToggleButton
\ ------------------------------------------------------------------------------
\  csp4th OOP             GtkToggleButton example.1                   MM-070323
\ ------------------------------------------------------------------------------
\                      Copyright (C) 2008 Manfred Mahlow
\
\                      This code is in the public domain.
\ ------------------------------------------------------------------------------

  GtkToggleButton definitions

  private vocabulary example.1  self example.1 definitions

  GtkToplevel     new window
  GtkHBox         new  hbox
  GtkToggleButton new   button.1
  GtkToggleButton new   button.2

  :noname ( wid data -- ) gtk main_quit ;  2 20 cb cb.destroy

  :noname ( wid data -- )
     cr ." button " . ." ( " . ." ) was toggled " ;  2 20 cb cb.toggled

  : run ( -- )
 
    " GtkToggleButton Example " window init

    3 window border-width !    300 window default-width !

    hbox init  hbox homogeneous yes  3 hbox spacing !  window add

    " Button 1" button.1 init hbox pack_start_defaults
    " Button _2" button.2 init hbox pack_start_defaults

    " toggled" cb.toggled 1 button.1 signal connect drop
    " toggled" cb.toggled 2 button.2 signal connect drop

    " destroy" cb.destroy 0 window signal connect drop

    window show_all

  ;

  hide cb.destroy  hide cb.toggled

  run term? [IF] ?? [ELSE] gtk main bye [THEN]

\ ------------------------------------------------------------------------------
\ Last revision: MM-090306  :: -> :noname
\                MM-080803  gtk quit -> gtk main_quit , show all -> show_all
\                           pack defaults start -> pack_start_defaults
