
   needs GtkToplevel
   needs GtkTooltips
 \ -----------------------------------------------------------------------------
 \  GtkToplevel Example 3  for csp4th                                 MM-060901
 \ -----------------------------------------------------------------------------
\                      Copyright (C) 2008 Manfred Mahlow
\
\                      This code is in the public domain.
\ ------------------------------------------------------------------------------

   oop definitions

   GtkToplevel new window
   GtkTooltips new tips

   :noname ( wid data -- ) tips destroy  gtk main_quit ;  2 10 cb cb.quit

   :noname ( wid event data -- true|false )
      cr
      ." A delete event occured.  The window is not destroyed because "
      ." the callback routine, assigned to the delete event, returned "
      ." 'TRUE'. Change the return value to 'FALSE' and the window will "
      ." be destroyed by a delete event. "
      cr cr
      ." To close the toplevel window, type  window destroy <enter>  in "
      ." this terminal. "
      cr
      true ;  3 10 cb cb.delete

   : run ( -- )

        " GtkToplevel : Example 3" window init

        300 window width-request !  200 window default-height !

        " delete_event" cb.delete 0 window signal connect drop

        " destroy" cb.quit 0 window signal connect drop

        tips init

        " Click on the windows close button and see the terminal output." 

        window wid tips !

        window show_all
   ;

   hide cb.quit  hide cb.delete

   run term? [IF] ?? [ELSE] gtk main bye [THEN]

 \ -----------------------------------------------------------------------------
 \ Last revision: MM-090306  :: -> :noname
\                 MM-080803  gtk quit -> gtk main_quit , show all -> show_all
\                 MM-080416  resize -> width-request , default-height
