
  needs GtkToplevel
  needs GtkTreeView
  needs GtkTreeViewColumn
  needs GtkTreeViewColumn Array
  needs GtkListStore
  needs GtkCellRendererText
  needs GtkTreeIter
\ ------------------------------------------------------------------------------
\  GtkTreeView example 1  for csp4th                                  MM-060901
\ ------------------------------------------------------------------------------
\                      Copyright (C) 2008 Manfred Mahlow
\
\                      This code is in the public domain.
\ ------------------------------------------------------------------------------

  gtk api definitions

  libgtk import gtk_tree_path_to_string ( *path -- *char )

  libgtk import g_free ( *char -- )


  GtkTreeView definitions

  private vocabulary example.1  self example.1 definitions  also gtk api

  GtkToplevel             new window
  GtkTreeView             new  view
  GtkTreeViewColumn       new   index
  GtkTreeViewColumn Array new   columns

  GtkCellRendererText     new  renderer
  GtkListStore            new  list


   : get ( -- ? )
         view selection @ 0if exit ." No item selected.  " -1 throw then
         list row !
         5 0 do dup i list value @ type space space loop drop ;

  :noname ( wid data -- )   list free  gtk main_quit
  ;  2 20 cb cb.destroy

  :noname ( wid.view path wid.column data -- )
     cr ." row activated on " >r rot . ." : "
     swap ." path=" dup . gtk_tree_path_to_string dup zcount type g_free
     ." , *column=" . r> ." , data=" .  cr get
   ; 4 20 cb cb.sel0

  :noname ( wid data -- ) cr ." Column " . ." : wid=" .
  ; 2 20 cb cb.clicked


  : run ( -- )

      " GtkTreeView example 1" window init   window position center

      5 window border-width !    275 150 window resize

      view init window add   view rules-hint on  0 view search-column !

      renderer init

      dup " ID" " text" 0 index init view append

      4 columns init

      dup " Name"        " text" 1  0 columns of init view append
      dup " Strasse Nr." " text" 2  1 columns of init view append
      dup " PLZ"         " text" 3  2 columns of init view append
          " Ort"         " text" 4  3 columns of init view append


      G_TYPE_INT  G_TYPE_STRING  G_TYPE_STRING  G_TYPE_STRING  G_TYPE_STRING

      5 list init view model !
0 if
      list append dup 0 0 list value !
                  dup 1 " Luise Musterfrau" list text !
                  dup 2 " Oldenburger Str. 25" list text !
                  dup 3 " 28219" list text !
                      4 " Bremen" list text !

      list append dup 0 1 list value !
                  dup 1 " Otto Mustermann" list text !
                  dup 2 " Schillerstr. 97"  list text !
                  dup 3 " 28218"  list text !
                      4 " Bremen" list text !

      list append dup 0 2 list value !
                  dup 1 " Museum für Brotkultur" list text !
                  dup 2 " Salzstadelgasse 10"  list text !
                  dup 3 " "  list text !
                      4 " Ulm" list text !
then

     list append 0 0 list value !
                 " Luise Musterfrau" 1 list text !
                 " Oldenburger Str. 25" 2 list text !
                 " 28219" 3 list text !
                 " Bremen" 4 list text !

     list append 1 0 list value !
                 " Otto Mustermann" 1 list text !
                 " Schillerstr. 97" 2 list text !
                 " 28218" 3 list text !
                 " Bremen" 4 list text !

     list append 2 0 list value !
                 " Museum für Brotkultur" 1 list text !
                 " Salzstadelgasse 10" 2 list text !
                 " " 3 list text !
                 " Ulm" 4 list text !

     index sort indicator on
     index sort ascending
     index clickable on

     4 0 do i columns of resizable on
            i columns of clickable yes
            " clicked" cb.clicked i 1+ i columns of signal connect drop
         loop

      " destroy" cb.destroy 0 window signal connect drop

      " row-activated" cb.sel0 0 view signal connect drop

      " clicked" cb.clicked 0 index signal connect drop

      window show_all

   ;

   hide cb.sel0  hide cb.clicked  hide cb.destroy

   previous

   run term? [IF] ?? [ELSE] gtk main bye [THEN]
\ ------------------------------------------------------------------------------
\ Last revision: MM-090307  DO LOOP ... -> do loop ...
\                MM-090306  :: -> :noname
\                MM-090101  do loop ... -> do loop ... ANS
\                MM-080803 Updated to last modification of GtkListStore
