
   needs GtkBin
\ ------------------------------------------------------------------------------
\  class GtkWindow         OOP Module for csp4th                      MM-060901
\ ------------------------------------------------------------------------------
\                    Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------
   gtk api definitions

    0 constant GTK_WINDOW_TOPLEVEL
    1 constant GTK_WINDOW_POPUP

    libgtk import gtk_window_new ( type -- *window )

    libgtk import gtk_window_resize ( *window width height -- )

    libgtk import gtk_window_set_transient_for ( *window *parent -- )


   oop definitions  gtk api

   class GtkWindow  GtkWindow definitions  GtkBin inherit  self seal

    m: title ( oid -- oid a u ) self " title" gchararray ;

    m: icon ( oid -- oid a u ) self " icon" gpointer ;

    \  *pixmap <window> icon !  ,  <window> icon @ ( -- *pixmap )

    m: icon-name ( oid -- oid a u ) self " icon-name" gchararray ;

    \ " gtk-preferences" <window> icon-name ! 

    m: default-height ( oid -- oid a u ) self " default-height" gint ;

    m: default-width ( oid -- oid a u )  self " default-width" gint ;

    m: destroy-with-parent ( oid -- oid a u )
       self " destroy-with-parent" gboolean ;

    m: modal ( oid -- oid a u ) self " modal" gboolean ;

    m: resizable ( oid -- oid a u ) self " resizable" gboolean ;

    iface default-size  self default-size definitions

     m: ! (O width height -- )
          this up default-height !  this up default-width ! ;

    self up definitions

    iface transient-parent  self transient-parent definitions

     m: ! ( wid.parent oid -- )
          self up wid swap gtk_window_set_transient_for ;

    self up definitions


    m: init (S GtkWindowType oid -- )
       >r \? cr ." creating Gtk" dup if ." Popup " else ." Toplevel " then
       gtk_window_new r> self init drop ;


    m: resize ( width height oid -- )
       \? cr ." resizing window " 
       self wid (? dup . ) -rot gtk_window_resize ;

    \ 1 1 window resize  resets the window to the minimal size


    iface position  self position definitions
           
     m: is ( <name> GtkWindowPosition -- )
           ['] .. prelude create , 
           does> @ ( oid pos -- )
                 swap self up " window-position" gint ! ;

     self 0 is none
     self 1 is center
     self 2 is mouse

     hide is

   oop definitions
\ ------------------------------------------------------------------------------
\  Last revision: MM-090924  properties  icon  and  icon-name  added
\                 MM-080409  (O
\                 MM-080319  transient-parent added
\                 MM-080229  GtkWindow moved from gtk api to oop
\                 MM-080131  default-size added

