
  needs c api
\ ------------------------------------------------------------------------------
\  os time&date                 OOP Module for csp4th                 MM-060901
\ ------------------------------------------------------------------------------
\                       Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------

  c api definitions

  libc import time as os_time ( a|0 -- sec ) 

  \ returns seconds since midnight Jan 1 1970 on TOS and at addr a,
  \ if addr a isn't 0

  libc import localtime as os_localtime ( a1 -- a2 )

  oop definitions

   [DEFINED] os not [IF] iface os [THEN]

   : hh:mm:ss ( ss mm hh  -- a u )
               " hh:mm:ss" drop 1- >r 
               2 '0 (p.r) r@ place  ': r@ c+place 
               2 '0 (p.r) r@ +place ': r@ c+place
               2 '0 (p.r) r@ +place r> count ;

   : dd.mm.yyyy ( yyyy mm dd -- a u )
               " dd.mm.yyyy" drop 1- >r 
               2 '0 (p.r) r@ place  '. r@ c+place 
               2 '0 (p.r) r@ +place '. r@ c+place
               4 '0 (p.r) r@ +place r> count ;


  os definitions  c api

  iface time  self time definitions

   m: @ ( -- ss mm hh )
        pad os_time drop  pad os_localtime 3 0 do dup @ swap cell+ loop drop ;

   m: ? ( -- ) self @ hh:mm:ss type ;

  os definitions  c api

  iface date  self date definitions

   m: @ ( -- yyyy mm dd ) 0 os_time pad ! pad os_localtime 
                          5 cells +  dup @ 1900 +
                          swap cell- dup @ 1+
                          swap cell- @ ;

   m: ? ( -- ) self @ dd.mm.yyyy type ;

   oop definitions
\ ----------------------------------------------------------------------
\ Last revision: MM-090101  do loop ... -> DO LOOP ...
