\ tutorial-markup.4th
\ ------------------------------------------------------------------------------\  Minimalistic Markup for Interactive cspForth Tutorials             MM-090923
\ ------------------------------------------------------------------------------
\                    Copyright (C) 2009 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ ------------------------------------------------------------------------------
  needs help

  : ?in ( -- )
        >in @ c@ ( dup . ) 10 = if >in ++ cr then ( >in @ c@ . ) ;

  macro
  : <t> ( -- )
        ?in cr begin >in ++ 10 parse dup while type cr repeat 2drop ;

  macro
  : \<b> ( -- ) bold [compile] <t> ;

  macro
  : \<n> ( -- ) normal [compile] <t> ;

0 [IF]
  : e" ( a u -- )
     2dup bl skip 0if drop 2drop exit then drop
     2dup compiling? 0if cr type normal ."   <Enter>" bold key drop 
                     else type cr then evaluate ; 
  \ when <Enter> is preceeded by blanks or spaces, a failure occures when a
  \ signal connect command is displayed in the tutorial.
  \ when normal is commented out, the failure disappeares !  Why ????
  \ the normal ... bold sequence is the problem, i don't know why
[ELSE]
  : e" ( a u -- )
     2dup bl skip 0if drop 2drop exit then drop
     2dup compiling? 0if cr type ."   <Enter>" key drop 
                     else type cr then evaluate ; 
[THEN]

  macro
  : \<c> ( -- )
        bold ?in begin >in ++ 10 parse dup while e" repeat 2drop ;

  macro
  : \<?> normal cr ." <Enter>" key drop ;

\ ------------------------------------------------------------------------------
