: reset s0 [ $c031c689 , ;
inline : drop [ $768d068b , $04 1b, ;
inline : 2drop [ $8d04468b , $0876 2b, ;

macro : | 10 parse 2drop ;
macro : ( ') parse 2drop ;

| This file has the base functions that most Forths expect to have available

inline : aligned [ $8303c083 , $fce0 2b, ; | add eax, 3; and eax, -4
inline : 0 [ $89fc768d , $c03106 3b, ;
inline : 1 [ $89fc768d , $40c03106 , ;
inline : 2 [ $89fc768d , $40c03106 , $40 1b, ;
inline : -1 [ $89fc768d , $48c03106 , ;
inline : pop>ebx [ $068bc389 , $04768d 3b, ;
inline : - pop>ebx [ $d829 2b, ;
inline : + pop>ebx [ $d801 2b, ;
inline : and pop>ebx [ $d821 2b,  ;
inline : or pop>ebx [ $d809 2b, ;
inline : xor pop>ebx [ $d831 2b, ;
inline : not [ $1901f883 , $c0 1b, ;	| cmp eax,1 ; sbb eax,eax
inline : invert [ $d0f7 2b, ;	| not eax
inline : negate [ $d8f7 2b, ;	| neg eax
inline : 1+ [ $40 1b, ;
inline : 1- [ $48 1b, ;
| inline : << [ $d3adc189 , $e0 1b, ;     MM-081113
inline : lshift [ $d3adc189 , $e0 1b, ;  
| inline : >> [ $d3adc189 , $e8 1b, ;     MM-081113
inline : rshift [ $d3adc189 , $e8 1b, ;
inline : +! [ $01adc389 , $ad03 2b, ;
inline : @ [ $008b 2b, ;
inline : ! [ $18891e8b ,  $adad 2b, ;
inline : w@ [ $00b70f 3b, ;
inline : swap [ $068bc389 , $1e8990 3b, ;
inline : * [ $c68326f7 , 4 1b, ;
inline : ++ [ $ad00ff 3b, ;
inline : -- [ $ad08ff 3b, ;
inline : cells [ $02e0c1 3b, ;
inline : cell+ [ $04408d 3b, ;
inline : cell- [ $fc408d 3b, ;
inline : rot [ $46870687 , 4 1b, ;
inline : -rot [ $87044687 , 6 1b, ; 
 inline : dup [ $89fc768d , 6 1b, ;
inline : c@ [ $00b60f 3b, ; | movzx eax, byte [eax]
inline : nip [ $4768d 3b, ; | lea esi, [esi+4]
inline : pick [ $86048b 3b, ; | mov eax, [esi+4*eax]
inline : r> dup [ $58 1b, ;
inline : r@ r> [ $50 1b, ;
inline : >r [ $ad50 2b, ;
inline : rdrop [ $5b 1b, ;
inline : 0; [ $0275c009 , $c3ad 2b, ; | or eax, eax; jnz .done; lodsd; ret; .done:
inline : abs [ $29d03199 , $d0 1b, ; | cdq; xor eax, eax; sub eax, edx

| MM-090415 The inline version fails under some conditions. Reason not found.
| inline : @execute [ $ffad188b , $e3 1b, ; | mov ebx, [eax]; lodsd; jmp ebx
: @execute [ $ffad188b , $e3 1b, ; | mov ebx, [eax]; lodsd; jmp ebx

inline : rp@ dup [ $e089 2b, ;	| get current ESP
inline : rpick  [ $84048b 3b, ; | mov eax, [4*eax+esp]
inline : 2* [ $e0d1 2b, ;
inline : 2/ [ $f8d1 2b, ;
| forth
: off [ $1889db31 , ] drop ;
: on  [ $894bdb31 , $18 1b, ] drop ;
: >lit 6 + ;   : >class 4 - ;   : >size 8 + ;   : >xt 4 + ;   : >name 9 + ;
: count dup c@ swap 1+ swap ;
: */ [ $89adc189 , $ebf7adc3 , $f9f7 2b, ; | mov ecx, eax;drop;mov ebx,eax;drop;imul ebx;idiv ecx
: here (here) @ ;
: allot (here) +! ;
: over [ $89fc768d , $04468b06 , ;
: 2over [ $8b08ee83 , $06891046 , $0c468b 3b, ;
: max [ $39adc389 , $89027fd8 , $d8 1b, ;
: min [ $39adc389 , $89027cd8 , $d8 1b, ;
: w! [ $66adc389 , $ad0389 3b, ;

| --- moved from if.f to this file -------- MM-061003
| : if) 0 , here ;                               | MM-071021
| : back compile, here 5 - ++ ;                  | MM-070517
| : back [ ' compile, ] compile, here 5 - ++ ;   |

| MM-071021 if .. refactored

| macro : then align here over - swap cell- ! $9090 2b, ;
| macro : 0if $0fadc085 , $85 1b, if) ; | test eax, eax; lodsd; jnz ...

| : if) here 0 , ;  | MM-080531

  : ahead ( -- a ) here 0 , ;

  : ?branch ( -- a )
    | Compiles the code to branch if TOS is true.
    $0fadc085 , $85 1b, ahead ;

  : branch ( -- a ) $E9 1b, ahead ;   | MM-080531

  : resolve> ( orig dest -- ) over - cell- swap ! ;  | MM-080531

macro : 0if ( -- orig ) ?branch ;

macro : then ( orig -- ) here ( orig dest ) resolve> ;

| -----------------------------------------------------------------------------

| : ?huh ( a u 0|xt -- ) 0if drop type 32 emit '? emit 32 emit -13 throw then ;  | MM-070522

  : ?hu ( a u 0|xt -- xt )
        dup 0if drop type 32 emit '? emit 32 emit -13 throw then ;

| : ' ( "name" -- a u 0|xt ) parsews find ;     MM-061003
  : (') ( "name" -- a u 0|xt ) parsews find ;
| : ' ( "name" -- xt ) (') dup ?huh ;  | redefinition with error check  MM-070522
  : ' ( "name" -- xt ) (') ?hu ;  | redefinition with error check

| : '' ( "name" -- a u 0|xt ) parsews (find) ;  MM-061003
  : ('') ( "name" -- a u 0|xt ) parsews (find) ; 
| : '' ( "name" -- xt ) ('') dup ?huh ; | MM-070522
  : '' ( "name" -- xt ) ('') ?hu ;

|  : back [ ' compile, ] compile, here 5 - ++ ;   | MM-080531


: pdoes last @ >xt @ 1+ r> over - cell- swap !  ;
: dodoes [ $89fc768d , $53585b06 , ; | dup; pop ebx; pop eax; push ebx

: alias ( xt -- ) header -hide last @ >xt ! ;

| ' literal alias literal,   | MM-070516  not really needed, see p:

| macro : p: parsews (find) dup cell+ @ literal, cell- @ compile ; MM-061003
| macro : p: ( -- )  | redefinition with error check
        | parsews (find) dup ?huh dup cell+ @ literal, cell- @ compile ; MM-070516
        | parsews (find) dup ?huh dup >xt   @ literal, >class @ compile ;
        | parsews (find) dup ?huh dup >xt @ [ ' literal compile, ] >class @ compile, ;

| The above p: compile the xt ( as literal and ) and a call to the word class doer.
| That makes no sense. Only a call to the xt should be compiled ( see the outer 
| interpreter in csp4th-core.asm.

|  macro : p: ( "name" -- ) parsews find dup ?huh compile, ;  | MM-070516

| macro : [compile] ( "name" -- ) parsews find dup ?huh compile, ;  | MM-070516 MM-070517
| macro : [compile] ( "name" -- ) parsews find dup ?huh [ ' compile, ] compile, ;  | MM-070517
  macro : [compile] ( "name" -- ) parsews find ?hu [ ' compile, ] compile, ;  | MM-070517 MM-070522

| macro : ['] parsews find p: literal ;               | MM-061003
| macro : ['] ( "name" -- ) (') dup ?huh p: literal ; |
| macro : ['] ( "name" -- ) (') dup ?huh [compile] literal ; | MM-070516 MM-070522
  macro : ['] ( "name" -- ) (') ?hu [compile] literal ; | MM-070516 MM-070522

| macro : does> ['] pdoes compile, ['] dodoes compile, ;                       | MM-070517
  macro : does> ['] pdoes [compile] compile, ['] dodoes [compile] compile, ; |

| forth
| : :: here  last off ( for words without header ) p: ] ;         | MM-070516
| : :: here  last off ( for words without header ) [compile] ] ;  | MM-070517
| : :: here  last off ( for words without header ) ] ;            | MM-070519
| : :: ( -- xt ) align here  last off ] ;       | MM-090306  MM-071118
|  ' :: alias :noname                           |
  : :noname ( -- xt ) align here  last off ] ;  |

: is ' 1+ ! ;


| ' dovar : create parsews : (create) (header) literal compile ;  | MM-060816
| ' dovar : (create) (header) -hide literal compile, ;           | MM-070516 MM-070517
| ' dovar : (create) (header) -hide literal [compile] compile, ; | MM-070517
| : create parsews (create) ;

  ' dovar : created (header) -hide literal [compile] compile, ; | MM-080920
  : create parsews created ;

| : noop ; ' noop : defer literal : defer! header $bb 1b, ,  $e3ff 2b, ; | MM-060816

  : defer! header -hide $bb 1b, ,  $e3ff 2b, ;

  : noop ;  ' noop : defer literal defer! ;

: defer@ 1+ @ ;


| : variable 0 : variable, create , ;  MM-060816

  : variable, create , ;    : variable 0 variable, ;

: constant create , does> @ ;
32 constant bl
: space bl emit ;
: cr 10 emit ;
macro : chars ;
: 2swap [ $87044687 , $085e871e , $1e87 2b, ;
| mov ebx,eax; move eax, [esi]; cdq; idiv ebx; mov [esi], edx
: /mod  [ $068bc389 , $89fbf799 , $16 1b, ;
: / /mod nip ;
: mod /mod drop ;
: hex 16 base ! ;   : decimal 10 base ! ;   : binary 2 base ! ;   : octal 8 base ! ;
: tuck swap over ;
: c! [ $18881e8b , $8d04468b , $876 2b, ; | mov ebx, [esi]; mov [eax], bl; drop2

: (.) 0 (.r) ;
: .r (.r) type space ;
: . (.) type space ;

: u.r (u.r) type space ;  | MM-090409
: (u.) 0 (u.r) ;          |
: u. (u.) type space ;    |




: bye 0 (bye) ;
-1 constant true   | : true -1 ;  MM-061003
 0 constant false  | : false 0 ;
: ?dup [ $0574c085 , $89fc768d , $6 1b, ; | test eax, eax; jz .1; dup; .1:

| : sp [ $8904ee83 , $f08906 3b, ;   | from os.f , MM-060601
: sp@ [ $8904ee83 , $f08906 3b, ;   | renamed MM-070902
: sp! [ $c031c689 , ] drop ;  | new MM-070902

: depth s0 [ $f029 2b, ] 4 / 1- ;

notail : >rr r> r> rot >r >r >r ;
notail : rr> r> r> r> -rot >r >r ;
| forth
defer key?
defer ekey

| MM-070516  p: -> [compile] , compile -> compile,
| MM-070517 [compile] ] -> ] because ] is no longer a macro
| MM-070517 compile, is now immediate
| MM-070519 :: changed to reset (private) flag
| MM-070522 ?huh -> ?hu
| MM-070802 :: changed not to reset the (private) flag
| MM-070901  unhide renamed to -hide
| MM-070902  sp -> sp@
| MM-071118  :: changed to return an aligned xt
| MM-080815  revacore.asm -> csp4th-core.asm
| MM-080920  (create) renamed to created
| MM-090306  :: -> :noname
| MM-090409  u.r (u.) and u. added
