| inline : unloop [ $5b5b 2b, ;
| inline : leave [ $c35b5b 3b, ;

| forth
| : i dup [ $0824448b , $0424442b , ;
| : j dup [ $1024448b , $0c24442b , ;


loc:

: (loop)
	here - 1- 1- dup -125 <if
		| long jump!
		$850f 2b,
		cell- ,
	else
		| short jump!
		$75 1b, 1b, 
	then
	;

: resolve< ( dest orig -- ) dup >r cell+ - r> ! ;

macro : begin ( align ) here ; | MM-080531

| macro : again back ;           MM-080531
  macro : again ( dest -- )
                branch ( dest orig ) resolve< ;

| MM-080531 -----------------
 macro : until ( dest -- ) | compiling
               ( f -- )    | executing
               [compile] if ( dest orig ) resolve< ;

 macro : while ( dest -- orig dest ) | compiling
               ( f -- )              | executing
               [compile] if swap ;

 macro : repeat ( orig dest -- )
                [compile] again [compile] then ;
| ---------------------------


| macro : do $50adc389 , $ad50d829 , align here ; | mov ebx, eax;lodsd;push eax;sub
| macro : loop  $240cff 3b, | eax,ebx;push eax; lodsd
|		(loop)
|		$08c483 3b, ;
| macro : +loop  $ad240429 , | sub [esp], eax; lodsd
|		(loop)
|		$08c483 3b, ;

macro : 0until $adc085 3b,  | test eax, eax; lodsd
		(loop) ;

| forth

| MM-080530  Reva repeat -> begin , Reva while -> 0until
| MM-080531  until while repeat added , align removed in begin

| -----------------------------------------------------------------------------
| ANS complient do loop ...                                          MM-090101
| -----------------------------------------------------------------------------
| using gas syntax



 : dodo ( limit from -- )
        [
     here $59 1b,             | pop %ecx
          $c389 2b,           | mox %eax,%ebx \ save from
          $ad 1b,             | lodsl  \ get limit
          $05 1b, $80000000 , | add $80000000,%eax  \ limit+$80000000
          $50 1b,             | push %eax
          $c329 2b,           | sub %eax,ebx        \ from -(limit+$80000000)
          $53 1b,             | push %ebx
          $ad 1b,             | lodsl
          $51 1b,             | push %ecx
        ] ;                   | ret

 : do?do ( limit from -- )
         [ | $063b 2b,     | cmpl (%esi),%ebx
           $1e8b 2b,     | movl (%esi),%ebx
           $c339 2b,     | cmpl %eax,%ebx
           $0775 2b,     |    jne 1f
         ] 2drop [
           $C3 1b,       |    ret
           $05240483 ,   | 1: addl $5,(%esp)
           $e9 1b,       | jmp
           here - 4 - ,  | to here in dodo
         ] ;             | ret


 : doloop ( -- )   | call doloop | jmp back |
          [ $042444ff ,    |    incl 4(%esp)
      here  $0871     2b,  |    jno 1f
            $5b       1b,  |    pop %ebx
            $08c483   3b,  |    addl $8,%esp
            $05c383   3b,  |    addl $5,%ebx
            $53       1b,  |    push %ebx
          ] ;              | 1: ret  

 : do+loop ( n|u -- )  | call do+loop | jmp back |
            [ $04244401 ,    | addl %eax,4(%esp)
              $ad       1b,  | lodsl
              $e9       1b,  | jmp
              here - 4 - ,   | to here in doloop
            ] ;              | ret


| move this code to a better location -------------------------------------

 variable l#  l# off

 : : ( -- ) : l# off ;

 : :noname ( -- xt ) :noname l# off ;   |

| -------------------------------------------------------------------------

 macro : do ( -- do-sys ) ['] dodo [compile] compile, [compile] begin ;

 macro : ?do ( -- ) ['] do?do [compile] compile, branch [compile] begin ;

 : rake ( sys -- )
        | resolve backwards reference of loop/+loop
        dup [compile] again
        | if a leave was compiled into the loop, resolve its forward reference 
        l# @ begin 2dup ( a.do a.leave|0 ) u< while
               dup @ ( a.do a.leave a.leave.prev|0 ) swap [compile] then
             repeat l# !
        | if it's a ?do loop, resolve the forward reference of ?do
        cell- @ 0if [compile] then then
  ;

 macro : loop ( do-sys -- )  | doloop | jmp a.dest
              ['] doloop [compile] compile, rake ;

 macro : +loop ( do-sys -- )  | do+loop | jmp a.dest 
               ['] do+loop [compile] compile, rake ;

 macro : unloop ( -- ) $08c483   3b, ;

 macro : leave ( -- ) [compile] unloop branch l# @ over ! l# ! ;

 reveal begin
 reveal again
 reveal until
 reveal while
 reveal repeat
 reveal 0until
 reveal :
 reveal :noname
 reveal do
 reveal ?do
 reveal loop
 reveal +loop
 reveal unloop
 reveal leave
 loc;

 : i ( -- i )
     dup 
     [ $0424448b ,  | movl 4(%esp),%eax
       $08244403 ,  | addl 8(%esp),%eax
     ] ;            | ret

 : j ( -- j )
     dup
     [ $0c24448b ,  | movl 12(%esp),%eax
       $10244403 ,  | addl 16(%esp),%eax
     ] ;            | ret

| MM-090306  :: -> :noname
| MM-090101/090307  ANS compliant DO LOOP ... added
| MM-090307  DO LOOP -> do loop ...
| MM-090919  code restructured with loc: , loc;

