: lcount dup cell+ swap @ ;
: 0term 2dup + 0 swap c! ;
: lplace 2dup ! cell+ swap 0term cmove ;
: +lplace  ( a n buf )
	dup >r lcount + ( a n a' r:buf )
	r> swap >r		( a n buf r:a' )
	2dup +! cell+ drop r> swap 0term cmove
	;
: c+lplace ( c lstr -- )
	>r r@ lcount + c!
	r> dup ++ lcount 0term 2drop
	;
: asciiz, dup 1b, here, 0 1b, ; 
: asciizl, dup , here, 0 1b, ; 
| variable (s^)  MM-061004
: dostr 
	r> dup count | retaddr str count
	rot over + 1+ 1+ >r | str count
	;
: dolstr
	r> dup lcount | retaddr str count
	rot over + cell+ 1+ >r | str count
	;
| compile string (use short version if possible) :
| : (") dup 256 <if ['] dostr compile, asciiz, else ['] dolstr compile, asciizl, then ; | MM-070517
 : (") dup 256 <if ['] dostr [compile] compile, asciiz, else ['] dolstr [compile] compile, asciizl, then ;  | MM-070517

| put string into 'rotating' temp area        MM-060820
| : "" (s^) @ 1+ 8 mod dup (s^) ! 
|      256 * str0 + dup >r place r> count ;

| ------------- MM-060820 061004
loc:

str0 8 256 * + constant strX  | MM-060820

variable (s^)

str0 (s^) !  | (s^) points to the first byte after the last allocated buffer

| Returns the start address of a buffer for u bytes in the rotating temp area and
| updates the pointer (s^) accordingly.
: (buf) ( u -- a )  | a = (s^) , if (s^) + u < strX , otherwise it's str0
     dup (s^) @ + strX < if (s^) @ swap (s^) +! else str0 + (s^) ! str0 then ;

| : "" ( a1 u -- a2 u )
|      dup 2 + (buf) dup >r place r> count  ( space '" emit '" emit '= emit over . space) ;

: "" ( a1 u -- a2 u )
     dup 2 + (buf) dup >r placez r> count  ( space '" emit '" emit '= emit over . space) ;


reveal (buf)
reveal ""
loc;
| ----------------------

macro : " '" parse\ compiling? if (") else "" then ;
| macro : ." '" parse/ compiling? if (") p: type else type then ;            | MM-070516
| macro : ." '" parse/ compiling? if (") ['] type compile, else type then ;  | MM-070517
  macro : ." '" parse\ compiling? if (") ['] type [compile] compile, else type then ;

: (^) ." (^) was renamed to (buf) " -13 throw ; | MM-061004  remove this later

: zt ( a u -- a' )
| Return the counted string a,u, that may be zero terminated or not, as a 
| zero-terminated one a'. If the counted string is already zero terminated,
| simply drop the count u. Otherwise copy the string zero-terminated to the
| rotating string buffer and return its new address on the stack.
  2dup + c@ if "" then drop ;

| forth
| : c+place ( c cstr -- ) dup ++ count +  0 over c! 1- c! ; -> core MM-090306
: chop ( a n c -- a1 n1 ) >r 2dup r> /char nip - ;
: -chop ( a n c -- a1 n1 ) >r 2dup r> \char nip - ;
: split over 0if drop false exit then  | MM-070325
        >r 2dup r> /char 0; 
	1- swap 1+ swap 2swap
	2 pick 1+ - true ;

| MM-070325  split changed to handle string size u=0.
| MM-070510  ;; -> exit
| MM-070516  fault fixed : 'p: type' -> '['] type compile,'
|            compile -> compile,
| MM-070517  compile, is now immediate
| MM-070906  moved zt from csp-forth.f to string.f
| MM-080101  move renamed to cmove
| MM-080920  parse/ renamed to parse\
| MM-090304  place --> placez
| MM-090306  c+place moved to the core
